<?php

/**
 * i-doit
 *
 * SM-VIEW Maps API model
 *
 * @package i-doit
 * @subpackage smview_maps
 * @author Steve Groeber <steve.groeber@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 * @license http://www.i-doit.com/license
 */
final class isys_api_model_maps extends isys_api_model {

    public function route($p_method, $p_params) {

        if($p_params["debug"] == true){
            ini_set('display_errors', 1);
            ini_set('display_startup_errors', 1);
            error_reporting(E_ERROR);
        } else {
            ini_set('display_errors', 0);
            ini_set('display_startup_errors', 0);
            error_reporting(0);
        }

        // Build model class
        $l_modelclass = 'maps_api_model_' . $p_method;

        //session update
        isys_application::instance()->session->start_dbsession();

        // Call data method and format data:
        if (class_exists($l_modelclass)) {
            $l_model = new $l_modelclass();
            if (isset($p_params['option']) == false && method_exists($l_model, 'read')) {
                $this->m_data = $l_model->read($p_params);

                //dynamic loading of function
            } elseif (method_exists($l_model, $p_params['option']) && is_callable(array($l_model, $p_params['option']))) {
                $this->m_data = call_user_func(
                    array($l_model, $p_params['option']), $p_params
                );
            } else {
                throw new Exception('Could not read from model (' . $p_method . ') and function (' . $p_params['option'] . ')');
            }
        } else {
            throw new Exception('Model \'maps.' . $p_method . '\' does not exist');
        }

        return $this;
    }
}
