<?php

/**
 * SHD SM-VIEW Maps File API
 *
 * @package    i-doit
 * @subpackage smview_maps
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class maps_api_model_image implements isys_api_model_interface
{
    /**
     * Read objects.
     *
     * @param array $p_params
     *
     * $p_param structure:
     * array (
     *     'filter' => array|null,
     * )
     *
     * @return array
     * @throws isys_exception_api
     */
    public function read($p_params)
    {
        global $g_absdir;

        $api = new isys_api_model_shd_file();
        $return = $api->read($p_params);

        $path = $g_absdir . "/upload/images/sm-view" . $p_params["path"];
        if (is_file(($path))) {
            $size = getimagesize($path);

            $return['width'] = $size[0];
            $return['height'] = $size[1];
        } else {
            $return['width'] = 0;
            $return['height'] = 0;
        }
        return $return;
    }
}
