/******/ (function() { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "KkGx":
/***/ (function() {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "Yct5":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
var yfiles_1 = __webpack_require__("GsAs");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var ContextualToolbar = /** @class */ (function () {
    function ContextualToolbar(graphComponent, container, props) {
        this.graphComponent = graphComponent;
        this.container = container;
        this.props = props;
        // initialize a label model parameter that is used to position the node pop-up
        var nodeLabelModel = new yfiles_1.ExteriorLabelModel({ insets: 10 });
        this.nodeLabelModelParameter = nodeLabelModel.createParameter(yfiles_1.ExteriorLabelModelPosition.NORTH);
        // initialize a label model parameter that is used to position the edge pop-up
        var edgeLabelModel = new yfiles_1.EdgePathLabelModel({ autoRotation: false });
        this.edgeLabelModelParameter = edgeLabelModel.createDefaultParameter();
        this.selectedItems = [];
        this.dirty = false;
        this.registerUpdateListeners();
        this.registerClickListeners();
    }
    ContextualToolbar.prototype.setSelectedItems = function (array) {
        if (array === null) {
            // eslint-disable-next-line no-throw-literal
            throw "SelectedItems can't be null. To hide the toolbar, set an empty array.";
        }
        this.selectedItems = array;
        this.containsEdges = this.getSelectedEdges().length > 0;
        this.containsShapeNodes = this.getSelectedNodes().filter(function (item) {
            var data = item.tag;
            return parseInt(data.shapetype) > 0 ? item : null;
        }).length > 0;
        this.containsLabels = this.getSelectedLabels().length > 0;
        if (array.length > 0) {
            this.show();
        }
        else {
            this.hide();
        }
    };
    ContextualToolbar.prototype.applyNodeSetup = function (prop, value) {
        var _this = this;
        var labels = this.getSelectedLabels();
        labels.forEach(function (label) {
            var node = label.owner;
            var data = node.tag;
            var nodeSetup = NodeStyleSettings_1.NodeStyleSettings.getNodeSetupByMapObject(data);
            switch (prop) {
                case 'color':
                    nodeSetup.color = value;
                    break;
                case 'background_color':
                    nodeSetup.background_color = value;
                    break;
                case 'is_bold':
                    nodeSetup.is_bold = value == 'true';
                    break;
                case 'is_italic':
                    nodeSetup.is_italic = value == 'true';
                    break;
                case 'shape':
                    nodeSetup.shape_type = parseInt(value);
                    break;
            }
            _this.props.onUpdateNodeSetup(nodeSetup, true);
        });
    };
    ContextualToolbar.prototype.changeFontSize = function (doIncrease) {
        var _this = this;
        var labels = this.getSelectedLabels();
        labels.forEach(function (label) {
            var node = label.owner;
            var data = node.tag;
            var nodeSetup = NodeStyleSettings_1.NodeStyleSettings.getNodeSetupByMapObject(data);
            nodeSetup.size = doIncrease ? nodeSetup.size + 2 : nodeSetup.size - 2;
            _this.props.onUpdateNodeSetup(nodeSetup, true);
        });
    };
    ContextualToolbar.prototype.changeLevel = function (doIncrease) {
        var _this = this;
        var nodes = this.getSelectedNodes();
        nodes.forEach(function (node) {
            _this.props.onUpdateNodeLevel(node, doIncrease);
        });
    };
    ContextualToolbar.prototype.applyEdgeSetup = function (prop, value) {
        var _this = this;
        var edges = this.getSelectedEdges();
        edges.forEach(function (edge) {
            var data = edge.tag;
            var edgeSetup = EdgeStyleSettings_1.EdgeStyleSettings.getEdgeSetupByMapConnection(data);
            switch (prop) {
                case 'source_arrow':
                    edgeSetup.source_arrow_type = parseInt(value);
                    break;
                case 'target_arrow':
                    edgeSetup.target_arrow_type = parseInt(value);
                    break;
                case 'line_color':
                    edgeSetup.line_color = value;
                    break;
                case 'stroke':
                    edgeSetup.stroke = parseInt(value);
                    break;
                case 'style':
                    edgeSetup.style = parseInt(value);
                    break;
            }
            _this.props.onUpdateEdgeSetup(edgeSetup, true);
        });
    };
    ContextualToolbar.prototype.showPickerContainer = function (e) {
        var toggleButton = e.target;
        var pickerContainer = document.getElementById(toggleButton.getAttribute('data-container-id'));
        var show = toggleButton.checked;
        if (!show) {
            this.hideAllPickerContainer();
            return;
        }
        // hide all picker containers except for the one that should be toggled
        this.hideAllPickerContainer(toggleButton, pickerContainer);
        // position the container above/below the toggle button
        pickerContainer.style.display = 'block';
        var labelElement = document.querySelector("label[for=\"".concat(toggleButton.id, "\"]"));
        var labelBoundingRect = labelElement.getBoundingClientRect();
        var toolbarClientRect = this.container.getBoundingClientRect();
        var pickerClientRect = pickerContainer.getBoundingClientRect();
        pickerContainer.style.left = "".concat(labelBoundingRect.left +
            labelBoundingRect.width / 2 -
            pickerContainer.clientWidth / 2 -
            toolbarClientRect.left, "px");
        var gcAnchor = this.graphComponent.toPageFromView(new yfiles_1.Point(0, 0));
        if (toolbarClientRect.top - gcAnchor.y < pickerClientRect.height + 20) {
            pickerContainer.style.top = '55px';
            this.addClass(pickerContainer, 'bottom');
        }
        else {
            pickerContainer.style.top = "-".concat(pickerClientRect.height + 12, "px");
            this.removeClass(pickerContainer, 'bottom');
        }
        // timeout the fading animation to make sure that the element is visible
        setTimeout(function () {
            pickerContainer.style.opacity = '1';
        }, 0);
    };
    ContextualToolbar.prototype.hideAllPickerContainer = function (exceptToggleButton, exceptContainer) {
        var toggleButtons = document.querySelectorAll('input[data-container-id]');
        for (var i = 0; i < toggleButtons.length; i++) {
            var btn = toggleButtons[i];
            if (btn !== exceptToggleButton) {
                btn.checked = false;
            }
        }
        var pickerContainers = document.querySelectorAll('.picker-container');
        var _loop_1 = function (i) {
            var container = pickerContainers[i];
            if (container.style.opacity !== '0' && container !== exceptContainer) {
                container.style.opacity = '0';
                setTimeout(function () {
                    container.style.display = 'none';
                }, 300);
            }
        };
        for (var i = 0; i < pickerContainers.length; i++) {
            _loop_1(i);
        }
    };
    ContextualToolbar.prototype.getSelectedItems = function () {
        return this.selectedItems;
    };
    ContextualToolbar.prototype.getSelectedEdges = function () {
        return this.selectedItems.filter(function (item) { return yfiles_1.IEdge.isInstance(item); });
    };
    ContextualToolbar.prototype.getSelectedNodes = function () {
        return this.selectedItems.filter(function (item) { return yfiles_1.INode.isInstance(item); });
    };
    ContextualToolbar.prototype.getSelectedLabels = function () {
        var labels = [];
        this.selectedItems.forEach(function (item) {
            if (yfiles_1.ILabel.isInstance(item)) {
                labels.push(item);
            }
            else if (yfiles_1.INode.isInstance(item) || yfiles_1.IEdge.isInstance(item)) {
                item.labels.forEach(function (label) {
                    labels.push(label);
                });
            }
        });
        return labels;
    };
    ContextualToolbar.prototype.updateItemUI = function () {
        var nodeUI = document.getElementById('node-ui');
        var labelUI = document.getElementById('label-ui');
        var edgeUI = document.getElementById('edge-ui');
        var levelUI = document.getElementById('level-ui');
        if (this.containsShapeNodes) {
            this.addClass(this.container, 'node-ui-visible');
            nodeUI.style.display = 'inline-block';
        }
        else {
            this.removeClass(this.container, 'node-ui-visible');
            nodeUI.style.display = 'none';
        }
        if (this.containsLabels) {
            this.addClass(this.container, 'label-ui-visible');
            labelUI.style.display = 'inline-block';
        }
        else {
            this.removeClass(this.container, 'label-ui-visible');
            labelUI.style.display = 'none';
        }
        if (this.containsEdges) {
            this.addClass(this.container, 'edge-ui-visible');
            edgeUI.style.display = 'inline-block';
            this.removeClass(this.container, 'level-ui-visible');
            levelUI.style.display = 'none';
        }
        else {
            this.removeClass(this.container, 'edge-ui-visible');
            edgeUI.style.display = 'none';
            this.addClass(this.container, 'level-ui-visible');
            levelUI.style.display = 'inline-block';
        }
    };
    ContextualToolbar.prototype.updateLabelControlState = function () {
        var labels = this.getSelectedLabels();
        if (labels.length > 0) {
            var firstLabel = labels[0];
            var node = firstLabel.owner;
            var data = node.tag;
            var nodeSetup = NodeStyleSettings_1.NodeStyleSettings.getNodeSetupByMapObject(data);
            var fontBoldToggle = document.getElementById('font-bold');
            fontBoldToggle.checked = nodeSetup.is_bold;
            var fontItalicToggle = document.getElementById('font-italic');
            fontItalicToggle.checked = nodeSetup.is_italic;
        }
    };
    ContextualToolbar.prototype.show = function () {
        // clearTimeout(this.hideTimer)
        this.container.style.display = 'block';
        // we hide the picker containers such that we don't need to update their position if new elements are added to
        // the toolbar
        this.hideAllPickerContainer();
        // show hide UI for nodes and/or labels
        this.updateItemUI();
        // maybe initialize some label UI elements to match the current label style
        this.updateLabelControlState();
        // place the contextual toolbar
        this.updateLocation();
        this.container.style.opacity = '1';
    };
    ContextualToolbar.prototype.hide = function () {
        var _this = this;
        this.hideAllPickerContainer();
        this.container.style.opacity = '0';
        setTimeout(function () {
            _this.container.style.display = 'none';
        }, 300);
    };
    ContextualToolbar.prototype.updateLocation = function () {
        if (this.selectedItems.length === 0) {
            return;
        }
        var width = this.container.clientWidth;
        var height = this.container.clientHeight;
        var zoom = this.graphComponent.zoom;
        var dummyOwner;
        var labelModelParameter;
        if (this.containsEdges && !this.containsShapeNodes) {
            // if only edges are selected, we want to use the first edge as position reference
            dummyOwner = this.selectedItems.find(function (item) { return yfiles_1.IEdge.isInstance(item); });
            labelModelParameter = this.edgeLabelModelParameter;
        }
        else {
            // if nodes and edges are selected, we use the union of the node's bounding boxes as position reference
            dummyOwner = new yfiles_1.SimpleNode({
                layout: this.getEnclosingRect()
            });
            labelModelParameter = this.nodeLabelModelParameter;
        }
        // create a dummy label to let the LabelModelParameter compute the correct location
        var dummyLabel = new yfiles_1.SimpleLabel(dummyOwner, '', labelModelParameter);
        if (labelModelParameter.supports(dummyLabel)) {
            dummyLabel.preferredSize = new yfiles_1.Size(width / zoom, height / zoom);
            var newLayout = labelModelParameter.model.getGeometry(dummyLabel, labelModelParameter);
            this.setLocation(newLayout.anchorX, newLayout.anchorY - (height + 60) / zoom, width, height);
        }
    };
    ContextualToolbar.prototype.getEnclosingRect = function () {
        var enclosingRect = new yfiles_1.MutableRectangle();
        this.selectedItems.forEach(function (item) {
            if (yfiles_1.INode.isInstance(item) || yfiles_1.ILabel.isInstance(item)) {
                // we need the axis-parallel bounding rectangle, thus look out for oriented rectangles of the labels
                var bounds = yfiles_1.IOrientedRectangle.isInstance(item.layout) ? item.layout.bounds : item.layout;
                enclosingRect.setToUnion(enclosingRect, bounds);
            }
        });
        return enclosingRect;
    };
    ContextualToolbar.prototype.setLocation = function (x, y, width, height) {
        // Calculate the view coordinates since we have to place the div in the regular HTML coordinate space
        var viewPoint = this.graphComponent.toViewCoordinates(new yfiles_1.Point(x, y));
        var gcSize = this.graphComponent.innerSize;
        var padding = 15;
        var left = Math.min(gcSize.width - width - padding, Math.max(padding, viewPoint.x));
        var top = Math.min(gcSize.height - height - padding, Math.max(padding, viewPoint.y));
        // todo: get offset
        top += 120;
        this.container.style.left = "".concat(left, "px");
        this.container.style.top = "".concat(top, "px");
    };
    ContextualToolbar.prototype.registerUpdateListeners = function () {
        var _this = this;
        this.graphComponent.addViewportChangedListener(function () {
            if (_this.selectedItems.length > 0) {
                _this.dirty = true;
            }
        });
        this.graphComponent.graph.addNodeLayoutChangedListener(function () {
            if (_this.selectedItems.length > 0) {
                _this.dirty = true;
            }
        });
        this.graphComponent.addUpdatedVisualListener(function () {
            if (_this.selectedItems.length > 0 && _this.dirty) {
                _this.dirty = false;
                _this.updateLocation();
            }
        });
    };
    ContextualToolbar.prototype.registerClickListeners = function () {
        var _this = this;
        this.bindAction('#color-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#shape-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#font-color-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#edge-color-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#edge-stroke-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#edge-type-picker', function (e) { return _this.showPickerContainer(e); });
        this.bindAction('#source-arrow-picker', function (e) {
            var cb = document.getElementById('target-arrow-picker');
            cb.checked = false;
            var target = e.target;
            var pickerContainer = document.getElementById(target.getAttribute('data-container-id'));
            _this.removeClass(pickerContainer, 'target');
            _this.showPickerContainer(e);
        });
        this.bindAction('#target-arrow-picker', function (e) {
            var cb = document.getElementById('source-arrow-picker');
            cb.checked = false;
            var target = e.target;
            var pickerContainer = document.getElementById(target.getAttribute('data-container-id'));
            _this.addClass(pickerContainer, 'target');
            _this.showPickerContainer(e);
        });
        this.bindActions('#color-picker-colors > button', function (e) {
            var target = e.target;
            var color = target.getAttribute('data-color');
            _this.applyNodeSetup('background_color', color);
        });
        this.bindActions('#font-color-picker-colors > button', function (e) {
            var target = e.target;
            var color = target.getAttribute('data-color');
            _this.applyNodeSetup('color', color);
        });
        this.bindActions('#shape-picker-shapes > button', function (e) {
            var target = e.target;
            var shape = target.getAttribute('data-shape');
            _this.applyNodeSetup('shape', shape);
        });
        this.bindActions('#arrow-picker-types > button', function (e) {
            var target = e.target;
            var arrowType = target.getAttribute('data-type');
            var isTarget = _this.hasClass(target.parentElement, 'target');
            _this.applyEdgeSetup((isTarget ? 'target_arrow' : 'source_arrow'), arrowType);
        });
        this.bindActions('#stroke-thickness > button', function (e) {
            var target = e.target;
            var stroke = target.getAttribute('data-type');
            _this.applyEdgeSetup('stroke', stroke);
        });
        this.bindActions('#stroke-types > button', function (e) {
            var target = e.target;
            var style = target.getAttribute('data-type');
            _this.applyEdgeSetup('style', style);
        });
        this.bindActions('#edge-colors > button', function (e) {
            var target = e.target;
            var color = target.getAttribute('data-color');
            _this.applyEdgeSetup('line_color', color);
        });
        this.bindAction('#font-bold', function (e) {
            _this.hideAllPickerContainer();
            var target = e.target;
            _this.applyNodeSetup('is_bold', target.checked.toString());
        });
        this.bindAction('#font-italic', function (e) {
            _this.hideAllPickerContainer();
            var target = e.target;
            _this.applyNodeSetup('is_italic', target.checked.toString());
        });
        this.bindAction('#decrease-font-size', function () {
            _this.hideAllPickerContainer();
            _this.changeFontSize(false);
        });
        this.bindAction('#increase-font-size', function () {
            _this.hideAllPickerContainer();
            _this.changeFontSize(true);
        });
        this.bindAction('#decrease-level', function () {
            _this.hideAllPickerContainer();
            _this.changeLevel(false);
        });
        this.bindAction('#increase-level', function () {
            _this.hideAllPickerContainer();
            _this.changeLevel(true);
        });
    };
    ContextualToolbar.prototype.bindAction = function (selector, action) {
        var element = document.querySelector(selector);
        if (!element) {
            return;
        }
        element.addEventListener('click', function (e) {
            action(e);
        });
    };
    ContextualToolbar.prototype.bindActions = function (selectors, action) {
        var elements = document.querySelectorAll(selectors);
        if (!elements) {
            return;
        }
        for (var i = 0; i < elements.length; i++) {
            var element = elements[i];
            element.addEventListener('click', function (e) {
                action(e);
            });
        }
    };
    ContextualToolbar.prototype.addClass = function (e, className) {
        var classes = e.getAttribute('class');
        if (classes === null || classes === '') {
            e.setAttribute('class', className);
        }
        else if (!this.hasClass(e, className)) {
            e.setAttribute('class', "".concat(classes, " ").concat(className));
        }
        return e;
    };
    ContextualToolbar.prototype.removeClass = function (e, className) {
        var classes = e.getAttribute('class');
        if (classes !== null && classes !== '') {
            if (classes === className) {
                e.setAttribute('class', '');
            }
            else {
                var result = classes
                    .split(' ')
                    .filter(function (s) { return s !== className; })
                    .join(' ');
                e.setAttribute('class', result);
            }
        }
        return e;
    };
    ContextualToolbar.prototype.hasClass = function (e, className) {
        var classes = e.getAttribute('class');
        var r = new RegExp("\\b".concat(className, "\\b"), '');
        return r.test(classes);
    };
    ContextualToolbar.prototype.toggleClass = function (e, className) {
        if (this.hasClass(e, className)) {
            this.removeClass(e, className);
        }
        else {
            this.addClass(e, className);
        }
        return e;
    };
    return ContextualToolbar;
}());
exports["default"] = ContextualToolbar;


/***/ }),

/***/ "io/V":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MapsCompose = void 0;
var React = __webpack_require__("q1tI");
var view_component_1 = __webpack_require__("WBwp");
var styles_other_1 = __webpack_require__("AuVx");
var TextLabelStyle_1 = __webpack_require__("a17Q");
var ImageNodeStyle_1 = __webpack_require__("WrRr");
var ShapeNodeStyle_1 = __webpack_require__("Ms6H");
var ViewInputMode_1 = __webpack_require__("huui");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var EdgeMenu_1 = __webpack_require__("h609");
var TextMenu_1 = __webpack_require__("cw+J");
var TextNodeStyle_1 = __webpack_require__("v4wb");
var CursorEditorInputMode_1 = __webpack_require__("8iQy");
var NodeEditorInputMode_1 = __webpack_require__("apmn");
var EdgeEditorInputMode_1 = __webpack_require__("oqoH");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var CmdbObjectMenu_1 = __webpack_require__("3If0");
var ShapeMenu_1 = __webpack_require__("I4Gm");
var yfiles_1 = __webpack_require__("GsAs");
var StructureView_1 = __webpack_require__("R6cl");
var ContextualToolbar_1 = __webpack_require__("Yct5");
var MapMenu_1 = __webpack_require__("aOeG");
var ImageMenu_1 = __webpack_require__("DDrO");
var ajax_1 = __webpack_require__("qrt2");
var HtmlLabelStyle_1 = __webpack_require__("ja5B");
var MapsCompose = /** @class */ (function (_super) {
    __extends(MapsCompose, _super);
    function MapsCompose(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            is_editable: false,
            is_reloading: false,
            show_overview: false,
            show_structure: false,
            edit_mode: MapsCompose.EDIT_MODE_CURSOR,
            edge_setup: {
                stroke: EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_S,
                style: EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STYLE_SOLID,
                line_color: '#000000',
                source_arrow_type: EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_NONE,
                target_arrow_type: EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_DEFAULT
            },
            node_setup: {
                family: 'Dialog',
                size: 14,
                color: '#000000',
                background_color: '#7784AA',
                is_bold: false,
                is_italic: false,
                shape_type: null
            }
        };
        _this.setDefaultNodeStyle = _this.setDefaultNodeStyle.bind(_this);
        _this.setDefaultEdgeStyle = _this.setDefaultEdgeStyle.bind(_this);
        _this.renderGraph = _this.renderGraph.bind(_this);
        _this.handleMapEditable = _this.handleMapEditable.bind(_this);
        _this.handlePageReload = _this.handlePageReload.bind(_this);
        _this.handleFitBounds = _this.handleFitBounds.bind(_this);
        _this.handleShowOverview = _this.handleShowOverview.bind(_this);
        _this.handleShowStructure = _this.handleShowStructure.bind(_this);
        _this.handleEditMode = _this.handleEditMode.bind(_this);
        _this.updateEdgeSetup = _this.updateEdgeSetup.bind(_this);
        _this.updateNodeSetup = _this.updateNodeSetup.bind(_this);
        _this.updateNodeLevel = _this.updateNodeLevel.bind(_this);
        _this.updateHiddenNode = _this.updateHiddenNode.bind(_this);
        _this.handleDragOver = _this.handleDragOver.bind(_this);
        _this.handleDrop = _this.handleDrop.bind(_this);
        _this.div = React.createRef();
        _this.graphComponent = new view_component_1.GraphComponent('#yGraph');
        // create a filtered graph
        var fullGraph = new yfiles_1.DefaultGraph();
        var nodePredicate = function (node) { return !node.tag || !node.tag.filtered; };
        var edgePredicate = function (edge) { return !edge.tag || !edge.tag.filtered; };
        _this.graphComponent.graph = new yfiles_1.FilteredGraphWrapper(fullGraph, nodePredicate, edgePredicate);
        var mapData = JSON.parse(_this.props.data);
        _this.viewMode = new ViewInputMode_1.MyViewerInputMode(_this.props.base_path);
        _this.apiProps = {
            graph_component: _this.graphComponent,
            api_key: _this.props.api_key,
            api_url: _this.props.api_url,
            session: _this.props.session,
            map_id: mapData.map_id
        };
        _this.cursorEditMode = new CursorEditorInputMode_1.CursorEditorInputMode();
        _this.nodeEditMode = new NodeEditorInputMode_1.NodeEditorInputMode(_this.apiProps, {
            base_url: _this.props.base_url,
            node_setup: _this.state.node_setup
        }, _this.updateNodeSetup);
        _this.edgeEditMode = new EdgeEditorInputMode_1.EdgeEditorInputMode(_this.apiProps, _this.updateEdgeSetup, _this.state.edge_setup);
        _this.graphComponent.inputMode = _this.viewMode;
        _this.setDefaultNodeStyle(MapsCompose.EDIT_MODE_NODE);
        _this.setDefaultEdgeStyle(true);
        return _this;
    }
    MapsCompose.prototype.componentDidMount = function () {
        var _this = this;
        // Append the GraphComponent to the DOM
        this.div.current.appendChild(this.graphComponent.div);
        this.renderGraph();
        // add overview
        this.overviewComponent = new view_component_1.GraphComponent('overviewComponent');
        var overviewInputMode = new yfiles_1.OverviewInputMode();
        overviewInputMode.canvasComponent = this.graphComponent;
        this.overviewComponent.inputMode = overviewInputMode;
        // sets the overview graph and fit the overview graph bounds
        this.overviewComponent.graph = this.graphComponent.graph;
        // updates the overview component then show the overview graph
        this.overviewComponent.updateVisualAsync().then(function () {
            _this.overviewComponent.fitGraphBounds();
        });
        // add structure view
        var map = JSON.parse(this.props.data);
        this.structureView = new StructureView_1.StructureView('#structureComponent', this.props.language, this.updateHiddenNode, map.title);
        this.structureView.setGraph(this.graphComponent.graph);
        this.structureView.onElementClicked = function (node) {
            var viewNode = _this.graphComponent.graph.foldingView
                ? _this.graphComponent.graph.foldingView.getViewItem(node)
                : node;
            if (viewNode) {
                _this.graphComponent.currentItem = viewNode;
                _this.graphComponent.selection.clear();
                _this.graphComponent.selection.setSelected(viewNode, true);
                yfiles_1.ICommand.ZOOM_TO_CURRENT_ITEM.execute(null, _this.graphComponent);
            }
        };
        this.nodeEditMode.setStructureView(this.structureView);
        // add contextual toolbar
        this.initContextualToolbar();
    };
    MapsCompose.prototype.initContextualToolbar = function () {
        var _this = this;
        this.contextualToolbar = new ContextualToolbar_1.default(this.graphComponent, window.document.getElementById('contextualToolbar'), {
            onUpdateNodeSetup: this.updateNodeSetup,
            onUpdateEdgeSetup: this.updateEdgeSetup,
            onUpdateNodeLevel: this.updateNodeLevel,
            edgeSetup: this.state.edge_setup
        });
        // when an item is right clicked
        this.nodeEditMode.addItemRightClickedListener(function (src, args) {
            var isSelected = _this.graphComponent.selection.filter(function (item) { return item == args.item; }).size > 0;
            if (!isSelected) {
                _this.graphComponent.selection.clear();
                _this.graphComponent.selection.setSelected(args.item, true);
            }
            _this.contextualToolbar.setSelectedItems([args.item]);
        });
        this.edgeEditMode.addItemRightClickedListener(function (src, args) {
            var isSelected = _this.graphComponent.selection.filter(function (item) { return item == args.item; }).size > 0;
            if (!isSelected) {
                _this.graphComponent.selection.clear();
                _this.graphComponent.selection.setSelected(args.item, true);
            }
            _this.contextualToolbar.setSelectedItems([args.item]);
        });
        // if an item is deselected or deleted, we remove that element from the selectedItems
        this.graphComponent.selection.addItemSelectionChangedListener(function (src, args) {
            if (!args.itemSelected) {
                _this.contextualToolbar.setSelectedItems([]);
            }
        });
    };
    MapsCompose.prototype.setDefaultNodeStyle = function (mode) {
        var graph = this.graphComponent.graph;
        graph.nodeDefaults.size = new view_component_1.Size(64, 64);
        if (mode == MapsCompose.EDIT_MODE_NODE || mode == MapsCompose.EDIT_MODE_MAP || mode == MapsCompose.EDIT_MODE_IMAGE) {
            graph.nodeDefaults.style = new ImageNodeStyle_1.MyImageNodeStyle(this.props.base_url);
            var labelModel = new view_component_1.ExteriorLabelModel({ insets: 5 });
            graph.nodeDefaults.labels.layoutParameter = labelModel.createParameter(view_component_1.ExteriorLabelModelPosition.SOUTH);
            graph.nodeDefaults.labels.style = new TextLabelStyle_1.TextLabelStyle(this.state.node_setup);
        }
        if (mode == MapsCompose.EDIT_MODE_SHAPE) {
            graph.nodeDefaults.style = new ShapeNodeStyle_1.MyShapeNodeStyle();
            var labelModel = new view_component_1.ExteriorLabelModel({ insets: 5 });
            graph.nodeDefaults.labels.layoutParameter = labelModel.createParameter(view_component_1.ExteriorLabelModelPosition.SOUTH);
            graph.nodeDefaults.labels.style = new TextLabelStyle_1.TextLabelStyle(this.state.node_setup);
        }
        if (mode == MapsCompose.EDIT_MODE_TEXT) {
            graph.nodeDefaults.style = new TextNodeStyle_1.TextNodeStyle();
            var labelModel = new view_component_1.InteriorLabelModel();
            this.graphComponent.graph.nodeDefaults.labels.layoutParameter = labelModel.createParameter(view_component_1.InteriorLabelModelPosition.CENTER);
        }
    };
    MapsCompose.prototype.setDefaultEdgeStyle = function (isPolyline) {
        var e = this.state.edge_setup;
        var options = {
            stroke: EdgeStyleSettings_1.EdgeStyleSettings.getEdgeStroke(e.stroke, e.style, e.line_color),
            sourceArrow: EdgeStyleSettings_1.EdgeStyleSettings.getEdgeArrow(e.source_arrow_type, e.stroke, e.line_color),
            targetArrow: EdgeStyleSettings_1.EdgeStyleSettings.getEdgeArrow(e.target_arrow_type, e.stroke, e.line_color)
        };
        if (isPolyline) {
            this.graphComponent.graph.edgeDefaults.style = new view_component_1.PolylineEdgeStyle(options);
        }
        else {
            this.graphComponent.graph.edgeDefaults.style = new styles_other_1.ArcEdgeStyle(options);
        }
    };
    MapsCompose.prototype.renderGraph = function () {
        var _this = this;
        // clear graph
        this.graphComponent.graph.clear();
        var mapData = JSON.parse(this.props.data);
        var graph = this.graphComponent.graph;
        var nodeMap = {};
        mapData.map_objects.forEach(function (obj) {
            var pos = obj.position.split(',');
            var x = parseInt(pos[0]);
            var y = parseInt(pos[1]);
            var w = parseInt(obj.width);
            var h = parseInt(obj.height);
            // re-calculate position from node-center (SM-VIEW) to top-left-corner (yFiles HTML)
            x = x - (w / 2);
            y = y - (h / 2);
            var node = graph.createNode(new view_component_1.Rect(x, y, w, h));
            node.tag = obj;
            nodeMap[obj.mapobject_id] = node;
            var label = graph.addLabel(node, obj.title);
            if (obj.realizertype == '2' || obj.realizertype == '1') {
                // shape node or text node
                if (obj.title.includes('</')) {
                    graph.setStyle(label, new HtmlLabelStyle_1.default(_this.state.node_setup));
                }
                else {
                    graph.setStyle(label, new TextLabelStyle_1.TextLabelStyle(_this.state.node_setup));
                }
                var labelModel = new view_component_1.InteriorLabelModel();
                var labelPos = view_component_1.InteriorLabelModelPosition.CENTER;
                graph.setLabelLayoutParameter(label, labelModel.createParameter(labelPos));
            }
            if (obj.realizertype == '0') {
                // image node
                // graph.setStyle(node, new MyImageNodeStyle(this.props.base_url));
                if (obj.title.includes('</')) {
                    graph.setStyle(label, new HtmlLabelStyle_1.default(_this.state.node_setup));
                }
                else {
                    graph.setStyle(label, new TextLabelStyle_1.TextLabelStyle());
                }
                // let labelPos = MapsCompose.getLabelPosition(obj.labelposition);
                var labelPos = NodeStyleSettings_1.NodeStyleSettings.getPosition(parseInt(obj.labelposition));
                var labelModel = new view_component_1.ExteriorLabelModel({ insets: 5 });
                graph.setLabelLayoutParameter(label, labelModel.createParameter(labelPos));
            }
            graph.setStyle(node, NodeStyleSettings_1.NodeStyleSettings.getNodeStyle(obj, _this.props.base_url));
            if (obj.textvisible == '0') {
                // remove label if text is not visible
                graph.remove(label);
            }
        });
        if (!mapData.map_connection) {
            return;
        }
        mapData.map_connection.forEach(function (obj) {
            var sourceNode = nodeMap[obj.source_shd_map_mapobject__id];
            var targetNode = nodeMap[obj.target_shd_map_mapobject__id];
            var edge = graph.createEdge(sourceNode, targetNode);
            edge.tag = obj;
            if (obj.textvisible && obj.textvisible == '1' && obj.title && obj.title != '') {
                var label = graph.addLabel(edge, obj.title);
                var labelModel = new view_component_1.InteriorLabelModel();
                var labelPos = view_component_1.InteriorLabelModelPosition.CENTER;
                graph.setStyle(label, new TextLabelStyle_1.TextLabelStyle());
                graph.setLabelLayoutParameter(label, labelModel.createParameter(labelPos));
            }
            if (obj.bends != '') {
                var bends = obj.bends.split(';');
                bends.forEach(function (b) {
                    var coord = b.split(',');
                    var x = parseInt(coord[0]);
                    var y = parseInt(coord[1]);
                    graph.addBend(edge, new view_component_1.Point(x, y));
                });
            }
            graph.setStyle(edge, EdgeStyleSettings_1.EdgeStyleSettings.getEdgeStyle(obj));
        });
        // set layerindex of each node
        var mapLayerIndex = mapData.layerindex.split(';');
        this.nodeLayerIndices = [];
        mapLayerIndex.forEach(function (objectId) {
            var mapObjectId = parseInt(objectId);
            if (!nodeMap[mapObjectId]) {
                return;
            }
            var node = nodeMap[mapObjectId];
            _this.graphComponent.graphModelManager.getCanvasObject(node).toFront();
            _this.nodeLayerIndices.push(mapObjectId);
        });
        this.graphComponent.fitGraphBounds();
    };
    MapsCompose.prototype.handleMapEditable = function () {
        var checked = !this.state.is_editable;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { is_editable: checked })); });
        this.graphComponent.inputMode = checked ? this.cursorEditMode : this.viewMode;
    };
    MapsCompose.prototype.handlePageReload = function () {
        var checked = !this.state.is_reloading;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { is_reloading: checked })); });
        // setTimeout(function () {
        //     if (! this.state.is_reloading) {
        //         return;
        //     }
        //     window.location.href = window.location.toString();
        // }, 60000);
    };
    MapsCompose.prototype.handleFitBounds = function () {
        this.graphComponent.fitContent();
    };
    MapsCompose.prototype.handleShowOverview = function () {
        var checked = !this.state.show_overview;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { show_overview: checked })); });
    };
    MapsCompose.prototype.handleShowStructure = function () {
        var checked = !this.state.show_structure;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { show_structure: checked })); });
    };
    MapsCompose.prototype.handleEditMode = function (event) {
        this.graphComponent.selection.clear();
        var editMode = event.currentTarget.value;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { edit_mode: editMode })); });
        switch (editMode) {
            case MapsCompose.EDIT_MODE_CURSOR:
                this.graphComponent.inputMode = this.cursorEditMode;
                break;
            case MapsCompose.EDIT_MODE_NODE:
            case MapsCompose.EDIT_MODE_SHAPE:
            case MapsCompose.EDIT_MODE_TEXT:
            case MapsCompose.EDIT_MODE_MAP:
            case MapsCompose.EDIT_MODE_IMAGE:
                this.nodeEditMode.allowNodeCreation(editMode == MapsCompose.EDIT_MODE_TEXT);
                this.graphComponent.inputMode = this.nodeEditMode;
                this.setDefaultNodeStyle(editMode);
                break;
            case MapsCompose.EDIT_MODE_EDGE:
                this.graphComponent.inputMode = this.edgeEditMode;
                break;
        }
    };
    MapsCompose.prototype.updateEdgeSetup = function (edgeSetup, updateSelectedEdges) {
        var _this = this;
        console.debug('update edge STATE');
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { edge_setup: edgeSetup })); }, function () {
            if (updateSelectedEdges) {
                // change settings of selected edges
                _this.edgeEditMode.updateSelectedEdges(edgeSetup);
            }
            // update edge editor props
            _this.edgeEditMode.updateEditorProps(edgeSetup);
            // always update default edge style to fit with displayed edge menu
            _this.setDefaultEdgeStyle(_this.graphComponent.graph.edgeDefaults.style instanceof view_component_1.PolylineEdgeStyle);
        });
    };
    MapsCompose.prototype.updateNodeSetup = function (nodeSetup, updateSelectedNodes) {
        var _this = this;
        console.debug('update node STATE');
        console.debug(nodeSetup);
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { node_setup: nodeSetup })); }, function () {
            // change settings of selected nodes
            if (updateSelectedNodes) {
                _this.nodeEditMode.updateSelectedNodes(nodeSetup);
            }
            // update node editor props
            _this.nodeEditMode.updateNodeSetup(nodeSetup);
            // always update default node style to fit with displayed font menu
            _this.setDefaultNodeStyle(_this.state.edit_mode);
        });
    };
    MapsCompose.prototype.updateHiddenNode = function (node, isHidden) {
        node.tag.filtered = isHidden;
        // re-evaluate the filter predicates to actually hide the items
        var filteredGraph = this.graphComponent.graph;
        filteredGraph.nodePredicateChanged();
    };
    MapsCompose.prototype.updateNodeLevel = function (node, doIncrease) {
        var _this = this;
        var data = node.tag;
        var id = data.mapobject_id;
        var pos = this.nodeLayerIndices.indexOf(id);
        var newPos = doIncrease ? pos + 1 : pos - 1;
        newPos = newPos < 0 ? 0 : newPos;
        // re-order node indices
        if (newPos >= this.nodeLayerIndices.length) {
            var k = newPos - this.nodeLayerIndices.length + 1;
            while (k--) {
                this.nodeLayerIndices.push(undefined);
            }
        }
        this.nodeLayerIndices.splice(newPos, 0, this.nodeLayerIndices.splice(pos, 1)[0]);
        // update map
        var map = JSON.parse(this.props.data);
        (0, ajax_1.api)('shd.map.update', {
            map_id: map.map_id,
            layerindex: JSON.stringify(this.nodeLayerIndices)
        }, this.apiProps).then(function () {
            if (doIncrease) {
                _this.graphComponent.graphModelManager.getCanvasObject(node).raise();
            }
            else {
                _this.graphComponent.graphModelManager.getCanvasObject(node).lower();
            }
        });
    };
    MapsCompose.prototype.handleDragOver = function (evt) {
        evt.preventDefault();
    };
    MapsCompose.prototype.handleDrop = function (evt) {
        evt.preventDefault();
        console.debug('handle drop');
        var transfer = JSON.parse(evt.dataTransfer.getData('text/json'));
        var style;
        var imagePath = null;
        var title = null;
        var tag = {
            title: null,
            textvisible: '1',
            realizertype: 0,
            shapetype: 0
        };
        switch (transfer.transfer_type) {
            case 'cmdb-object':
                style = new ImageNodeStyle_1.MyImageNodeStyle(this.props.base_url);
                title = transfer.object_title ? transfer.object_title : 'New Node';
                imagePath = this.props.base_url + transfer.icon;
                tag.isys_obj__id = transfer.object_id;
                break;
            case 'map':
                style = new ImageNodeStyle_1.MyImageNodeStyle(this.props.base_url);
                title = transfer.object_title ? transfer.object_title : 'Linked Map';
                imagePath = this.props.base_url + transfer.icon;
                tag.link = transfer.object_id.toString();
                break;
            case 'shape':
                style = new ShapeNodeStyle_1.MyShapeNodeStyle();
                tag.shapetype = transfer.object_id;
                tag.realizertype = 1;
                break;
            case 'image':
                style = new ImageNodeStyle_1.MyImageNodeStyle(this.props.base_url);
                title = transfer.object_title ? transfer.object_title : 'Image';
                tag.textvisible = '0';
                imagePath = transfer.object_title;
                tag.image_file = transfer.icon;
                tag.width = transfer.image_width ? transfer.image_width : 64;
                tag.height = transfer.image_height ? transfer.image_height : 64;
                break;
            default:
                return;
        }
        tag.imagepath = imagePath;
        tag.title = title;
        // get drop location
        var point = new view_component_1.Point(evt.clientX, evt.clientY);
        point = this.graphComponent.toWorldFromPage(point);
        var node = this.graphComponent.graph.createNodeAt(point, style, tag);
        // update node size if needed
        if (tag.width) {
            this.graphComponent.graph.setNodeLayout(node, new view_component_1.Rect(node.layout.topLeft, new view_component_1.Size(tag.width, tag.height)));
        }
        // save node
        this.nodeEditMode.setupNewNode(node);
    };
    MapsCompose.prototype.render = function () {
        var toolMenu = null;
        var menu = null;
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_NODE) {
            toolMenu = React.createElement(CmdbObjectMenu_1.CmdbObjectMenu, { api_props: this.apiProps, base_url: this.props.base_url, object_types: this.props.object_types, language: this.props.language });
        }
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_SHAPE) {
            toolMenu = React.createElement(ShapeMenu_1.ShapeMenu, { node_setup: this.state.node_setup, onNodeSetupChange: this.updateNodeSetup });
        }
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_TEXT) {
            toolMenu = React.createElement(TextMenu_1.TextMenu, { node_setup: this.state.node_setup, onNodeSetupChange: this.updateNodeSetup, language: this.props.language });
        }
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_IMAGE) {
            toolMenu = React.createElement(ImageMenu_1.ImageMenu, { base_url: this.props.base_url, api_props: this.apiProps, language: this.props.language });
        }
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_MAP) {
            toolMenu = React.createElement(MapMenu_1.MapMenu, { maps: this.props.maps, language: this.props.language });
        }
        if (this.state.edit_mode == MapsCompose.EDIT_MODE_EDGE) {
            toolMenu = React.createElement(EdgeMenu_1.EdgeMenu, { base_url: this.props.base_url, edge_setup: this.state.edge_setup, onEdgeSetupChange: this.updateEdgeSetup, language: this.props.language });
        }
        if (this.state.is_editable) {
            var className = this.state.show_overview || this.state.show_structure ? 'menu menu-with-overview' : 'menu';
            menu = React.createElement("div", { className: className },
                React.createElement("div", { className: "tools" },
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_CURSOR ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_CURSOR }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_CURSOR),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_NODE ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_NODE }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_NODE),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_SHAPE ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_SHAPE }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_SHAPE),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_TEXT ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_TEXT }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_TEXT),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_IMAGE ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_IMAGE }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_IMAGE),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_MAP ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_MAP }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_MAP),
                    React.createElement("button", { className: this.state.edit_mode == MapsCompose.EDIT_MODE_EDGE ? 'btn selected' : 'btn', type: "button", onClick: this.handleEditMode, value: MapsCompose.EDIT_MODE_EDGE }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MODE_EDGE)),
                toolMenu);
        }
        var iconUrl = this.props.base_url + 'images/icons/silk/';
        var overviewStyle = this.state.show_overview ? {} : { display: 'none' };
        var structureClass = this.state.show_overview ? 'structure-container-with-overview' : '';
        var structureStyle = this.state.show_structure ? {} : { display: 'none' };
        var map = JSON.parse(this.props.data);
        return React.createElement("div", { style: { height: '100%' } },
            React.createElement("div", { className: "settings" },
                React.createElement("ul", null,
                    React.createElement("li", null,
                        React.createElement("div", { className: this.state.show_overview ? 'navbar_item selected' : 'navbar_item', onClick: this.handleShowOverview },
                            React.createElement("img", { src: iconUrl + 'chart_organisation.png', alt: this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__OVERVIEW, width: "15px", height: "15px" }),
                            React.createElement("label", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__OVERVIEW)),
                        React.createElement("div", { className: "overview-container", style: overviewStyle },
                            React.createElement("div", { id: "overviewComponent" }, "\u00A0"))),
                    React.createElement("li", null,
                        React.createElement("div", { className: this.state.show_structure ? 'navbar_item selected' : 'navbar_item', onClick: this.handleShowStructure },
                            React.createElement("img", { src: iconUrl + 'outline.png', alt: this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__STRUCTURE, width: "15px", height: "15px" }),
                            React.createElement("label", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__STRUCTURE)),
                        React.createElement("div", { className: 'structure-container ' + structureClass, style: structureStyle },
                            React.createElement("div", { id: "structureComponent", className: "structure-view-container" }, "\u00A0"))),
                    React.createElement("li", null,
                        React.createElement("div", { className: this.state.is_editable ? 'navbar_item selected' : 'navbar_item', onClick: this.handleMapEditable },
                            React.createElement("img", { src: iconUrl + 'page_edit.png', alt: this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MAP, width: "15px", height: "15px" }),
                            React.createElement("label", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__EDIT_MAP))),
                    React.createElement("li", null,
                        React.createElement("div", { className: "navbar_item", onClick: this.handleFitBounds },
                            React.createElement("img", { src: iconUrl + 'arrow_out.png', alt: "", width: "15px", height: "15px" }),
                            React.createElement("label", null, "Fit Bounds"))),
                    React.createElement("li", null,
                        React.createElement("div", { className: this.state.is_reloading ? 'navbar_item selected' : 'navbar_item', onClick: this.handlePageReload },
                            React.createElement("img", { src: iconUrl + 'arrow_refresh.png', alt: this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__AUTO_RELOAD_PAGE, width: "15px", height: "15px" }),
                            React.createElement("label", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__AUTO_RELOAD_PAGE))))),
            React.createElement("div", { className: "map-name" },
                React.createElement("h2", null, map.title)),
            menu,
            React.createElement("div", { className: "graph", onDragOver: this.handleDragOver, onDrop: this.handleDrop },
                React.createElement("div", { className: "graph-component-container", ref: this.div })));
    };
    MapsCompose.EDIT_MODE_CURSOR = 'cursor';
    MapsCompose.EDIT_MODE_NODE = 'node';
    MapsCompose.EDIT_MODE_SHAPE = 'shape';
    MapsCompose.EDIT_MODE_MAP = 'map';
    MapsCompose.EDIT_MODE_IMAGE = 'image';
    MapsCompose.EDIT_MODE_TEXT = 'text';
    MapsCompose.EDIT_MODE_EDGE = 'edge';
    return MapsCompose;
}(React.Component));
exports.MapsCompose = MapsCompose;


/***/ }),

/***/ "R6cl":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StructureView = void 0;
var yfiles_1 = __webpack_require__("GsAs");
/**
 * basics from: https://github.com/yWorks/yfiles-for-html-demos/blob/master/demos/view/structureview/StructureView.js
 */
var StructureView = /** @class */ (function () {
    function StructureView(selector, language, onHideNode, mapName) {
        this.onHideNode = onHideNode;
        this.element2node = new Map();
        this.node2element = new yfiles_1.HashMap();
        this.groupElementCounter = 0;
        this.labelPlaceholder = language.LC__CMDB__CATG__SMVIEW_MAPS__PLACEHOLDER_EMPTY_SHAPE;
        this.container = document.querySelector(selector);
        this.container.setAttribute('class', 'structure-view-container');
        var graphList = document.createElement('ol');
        graphList.setAttribute('class', 'structure-view-list');
        this.container.appendChild(graphList);
        // Create the 'Graph' root folder
        var li = document.createElement('li');
        li.setAttribute('class', 'structure-view-group');
        var label = document.createElement('label');
        label.setAttribute('class', 'structure-view-expanded');
        label.setAttribute('for', 'graph-root');
        label.textContent = mapName;
        var collapseBox = document.createElement('input');
        collapseBox.id = 'graph-root';
        collapseBox.type = 'checkbox';
        collapseBox.setAttribute('checked', 'true');
        collapseBox.addEventListener('change', function (e) {
            var target = e.target;
            label.setAttribute('class', target.checked ? 'structure-view-expanded' : 'structure-view-collapsed');
        });
        li.appendChild(label);
        li.appendChild(collapseBox);
        this.rootListElement = document.createElement('ol');
        li.appendChild(this.rootListElement);
        // Append the 'Graph' root folder
        graphList.appendChild(li);
    }
    StructureView.prototype.getContainer = function () {
        return this.container;
    };
    StructureView.prototype.setGraph = function (value) {
        if (this.graph === value) {
            return;
        }
        var previousSyncFoldingState = this.syncFoldingState;
        if (this.graph) {
            // reset the StructureView
            this.syncFoldingState = false;
            this.clearStructure();
            this.foldingView = null;
            this.masterGraph = null;
        }
        this.graph = value;
        if (this.graph) {
            // re-initialize the StructureView with the new graph
            this.foldingView = value.foldingView;
            if (this.foldingView === null) {
                this.masterGraph = value;
            }
            else {
                this.masterGraph = this.foldingView.manager.masterGraph;
            }
            this.buildStructure();
        }
        this.syncFoldingState = previousSyncFoldingState;
    };
    StructureView.prototype.buildStructure = function () {
        var _this = this;
        this.clearStructure();
        // sort nodes
        var nodes = this.sortNodes(this.masterGraph.getChildren(null));
        // traverse the top-level nodes and recursively build the structure view
        nodes.forEach(function (node) { return _this.buildRecursiveTreeStructure(_this.rootListElement, node); });
    };
    StructureView.prototype.sortNodes = function (children) {
        var nodes = [];
        children.forEach(function (child) {
            nodes.push(child);
        });
        nodes.sort(function (a, b) {
            if (a.tag.layerindex > b.tag.layerindex)
                return 1;
            if (a.tag.layerindex < b.tag.layerindex)
                return 1;
            return 0;
        });
        return nodes;
    };
    StructureView.prototype.buildRecursiveTreeStructure = function (rootElement, node) {
        if (this.masterGraph.getChildren(node).size > 0) {
            // add a new group element with its children
            this.appendGroupElement(rootElement, node);
        }
        else {
            // add a leaf
            this.appendNodeElement(rootElement, node);
        }
    };
    StructureView.prototype.appendGroupElement = function (parentElement, groupNode) {
        var _this = this;
        // create the group
        var li = document.createElement('li');
        li.setAttribute('class', 'structure-view-group');
        // create the label
        var label = document.createElement('label');
        label.setAttribute('data-groupelement', 'group#' + this.groupElementCounter);
        label.setAttribute('class', 'structure-view-expanded');
        var text = groupNode.labels.size > 0 ? groupNode.labels.first().text : this.labelPlaceholder;
        label.textContent = text != '' ? text : this.labelPlaceholder;
        label.addEventListener('click', function () {
            if (typeof _this.onElementClicked === 'function') {
                _this.onElementClicked(groupNode);
            }
        });
        // the collapse/expand control is done via checkbox
        var collapseBox = document.createElement('input');
        collapseBox.id = 'group#' + this.groupElementCounter;
        collapseBox.type = 'checkbox';
        collapseBox.setAttribute('checked', 'true');
        // change folder icon if collapsed/expanded
        collapseBox.addEventListener('change', function (e) {
            var target = e.target;
            label.setAttribute('class', target.checked ? 'structure-view-expanded' : 'structure-view-collapsed');
            if (_this.syncFoldingState) {
                var masterGroupNode = _this.element2node.get(collapseBox.parentNode);
                var viewGroupNode = _this.foldingView.getViewItem(masterGroupNode);
                if (viewGroupNode === null) {
                    return;
                }
                if (!target.checked) {
                    _this.foldingView.collapse(viewGroupNode);
                }
                else {
                    _this.foldingView.expand(viewGroupNode);
                }
            }
            else {
            }
        });
        // append the actual DOM elements
        li.appendChild(label);
        li.appendChild(collapseBox);
        // append the group element to the root list
        var root = document.createElement('ol');
        li.appendChild(root);
        parentElement.appendChild(li);
        // keep track of the elements
        this.node2element.set(groupNode, li);
        this.element2node.set(li, groupNode);
        // increase unique IDs for the groups
        this.groupElementCounter++;
        // sort nodes
        var nodes = this.sortNodes(this.masterGraph.getChildren(groupNode));
        // recursively traverse the children
        nodes.forEach(function (child) { return _this.buildRecursiveTreeStructure(root, child); });
    };
    StructureView.prototype.appendNodeElement = function (parentElement, node) {
        var _this = this;
        // create the element
        var nodeElement = document.createElement('li');
        nodeElement.setAttribute('class', 'structure-view-node');
        var checkbox = document.createElement('input');
        checkbox.setAttribute('type', 'checkbox');
        checkbox.setAttribute('name', 'checkbox');
        checkbox.setAttribute('checked', 'checked');
        checkbox.addEventListener('click', function (evt) {
            var ckb = evt.target;
            _this.onHideNode(node, !ckb.checked);
        });
        nodeElement.appendChild(checkbox);
        var span = document.createElement('span');
        var text = node.labels.size > 0 ? node.labels.first().text : this.labelPlaceholder;
        span.textContent = text != '' ? text : this.labelPlaceholder;
        nodeElement.appendChild(span);
        // register the click callback
        span.addEventListener('click', function () {
            if (typeof _this.onElementClicked === 'function') {
                _this.onElementClicked(node);
            }
        });
        // append the element
        parentElement.appendChild(nodeElement);
        // keep track of the elements
        this.node2element.set(node, nodeElement);
        this.element2node.set(nodeElement, node);
    };
    StructureView.prototype.clearStructure = function () {
        while (this.rootListElement.hasChildNodes()) {
            this.rootListElement.removeChild(this.rootListElement.firstChild);
        }
        this.element2node.clear();
        this.node2element.clear();
        this.groupElementCounter = 0;
    };
    StructureView.prototype.getMasterNode = function (node) {
        return this.foldingView !== null ? this.foldingView.getMasterItem(node) : node;
    };
    return StructureView;
}());
exports.StructureView = StructureView;


/***/ }),

/***/ "huui":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MyViewerInputMode = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var MyViewerInputMode = /** @class */ (function (_super) {
    __extends(MyViewerInputMode, _super);
    function MyViewerInputMode(basePath) {
        var _this = _super.call(this) || this;
        _this.basePath = basePath;
        return _this;
    }
    MyViewerInputMode.prototype.onCanvasClicked = function (evt) {
        if (evt.clickCount != 2) {
            return;
        }
        if (!window.location.search.includes('nav=link')) {
            return;
        }
        // if location contains "nav=link" go back and load parent map
        window.history.back();
    };
    MyViewerInputMode.prototype.onItemDoubleClicked = function (evt) {
        if (!evt.item.tag) {
            return;
        }
        var map_id = evt.item.tag.link;
        if (!map_id) {
            return;
        }
        // load child map
        var url = window.location.origin + window.location.pathname;
        url += this.basePath + '&nav=link&treeNode=' + map_id + '&instance_id=' + map_id;
        window.location.href = url;
    };
    return MyViewerInputMode;
}(view_component_1.GraphViewerInputMode));
exports.MyViewerInputMode = MyViewerInputMode;


/***/ }),

/***/ "qrt2":
/***/ (function(__unused_webpack_module, exports) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.api = void 0;
function api(method, params, apiProps) {
    params = params || {};
    return fetch(apiProps.api_url, {
        method: 'POST',
        headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json',
            'X-RPC-Auth-Session': apiProps.session
        },
        credentials: 'same-origin',
        body: JSON.stringify({
            jsonrpc: '2.0',
            version: '2.0',
            id: 1,
            method: method,
            params: __assign({ apikey: apiProps.api_key }, params)
        })
    }).then(function (res) { return res.json(); });
}
exports.api = api;


/***/ }),

/***/ "Y10B":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
// add fetch polyfill (IE)
__webpack_require__("bZMm");
__webpack_require__("DxgT");
var React = __webpack_require__("q1tI");
var ReactDOM = __webpack_require__("i8i4");
var MapsCompose_1 = __webpack_require__("io/V");
var config = document.getElementById('C__CATG__SMVIEW_REACT_CONFIG').getAttribute('value');
if (config) {
    var cfg = JSON.parse(config);
    ReactDOM.render(React.createElement(MapsCompose_1.MapsCompose, __assign({}, cfg)), document.getElementById('editor'));
}


/***/ }),

/***/ "bisk":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ChangeNodePositionInputMode = void 0;
var yfiles_1 = __webpack_require__("GsAs");
var ajax_1 = __webpack_require__("qrt2");
var ChangeNodePositionInputMode = /** @class */ (function (_super) {
    __extends(ChangeNodePositionInputMode, _super);
    function ChangeNodePositionInputMode(api_props) {
        var _this = _super.call(this) || this;
        _this.api_props = api_props;
        return _this;
    }
    ChangeNodePositionInputMode.prototype.onDragFinished = function (evt) {
        _super.prototype.onDragFinished.call(this, evt);
        var node = this.api_props.graph_component.selection.selectedNodes.elementAt(0);
        var map_object = node.tag;
        var x = node.layout.x + (node.layout.width / 2);
        var y = node.layout.y + (node.layout.height / 2);
        var position = parseInt(x.toString()) + ',' + parseInt(y.toString());
        (0, ajax_1.api)('shd.map_object.update', {
            mapobject_id: map_object.mapobject_id,
            position: position
        }, this.api_props).then(function () {
            console.debug('node position successful changed');
        });
    };
    return ChangeNodePositionInputMode;
}(yfiles_1.MoveInputMode));
exports.ChangeNodePositionInputMode = ChangeNodePositionInputMode;


/***/ }),

/***/ "MnP8":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ChangeNodeSizeInputMode = void 0;
var yfiles_1 = __webpack_require__("GsAs");
var ajax_1 = __webpack_require__("qrt2");
var ChangeNodeSizeInputMode = /** @class */ (function (_super) {
    __extends(ChangeNodeSizeInputMode, _super);
    function ChangeNodeSizeInputMode(apiProps) {
        var _this = _super.call(this) || this;
        _this.apiProps = apiProps;
        return _this;
    }
    ChangeNodeSizeInputMode.prototype.onDragFinished = function (evt) {
        _super.prototype.onDragFinished.call(this, evt);
        var node = this.apiProps.graph_component.selection.selectedNodes.elementAt(0);
        var mapObject = node.tag;
        (0, ajax_1.api)('shd.map_object.update', {
            mapobject_id: mapObject.mapobject_id,
            width: node.layout.width,
            height: node.layout.height
        }, this.apiProps).then(function () {
            console.debug('node size successful changed');
        });
    };
    return ChangeNodeSizeInputMode;
}(yfiles_1.HandleInputMode));
exports.ChangeNodeSizeInputMode = ChangeNodeSizeInputMode;


/***/ }),

/***/ "8iQy":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CursorEditorInputMode = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var yfiles_1 = __webpack_require__("GsAs");
var CursorEditorInputMode = /** @class */ (function (_super) {
    __extends(CursorEditorInputMode, _super);
    function CursorEditorInputMode() {
        return _super.call(this, {
            clickableItems: view_component_1.GraphItemTypes.NODE,
            clickSelectableItems: view_component_1.GraphItemTypes.NODE,
            focusableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.NODE_LABEL,
            selectableItems: view_component_1.GraphItemTypes.NONE,
            marqueeSelectableItems: view_component_1.GraphItemTypes.NONE,
            movableItems: view_component_1.GraphItemTypes.NONE,
            deletableItems: view_component_1.GraphItemTypes.NONE,
            labelEditableItems: view_component_1.GraphItemTypes.NONE,
            allowClipboardOperations: false,
            allowGroupingOperations: false,
            allowDuplicate: false,
            allowAddLabel: false,
            allowEditLabel: false,
            allowCreateNode: false,
            allowCreateEdge: false,
            allowCreateBend: false
        }) || this;
    }
    return CursorEditorInputMode;
}(yfiles_1.GraphEditorInputMode));
exports.CursorEditorInputMode = CursorEditorInputMode;


/***/ }),

/***/ "m9v7":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EdgeCreationInputMode = void 0;
var yfiles_1 = __webpack_require__("GsAs");
var ajax_1 = __webpack_require__("qrt2");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var EdgeCreationInputMode = /** @class */ (function (_super) {
    __extends(EdgeCreationInputMode, _super);
    function EdgeCreationInputMode(apiProps, editorProps) {
        var _this = _super.call(this) || this;
        _this.enabled = true;
        _this.apiProps = apiProps;
        _this.editorProps = editorProps;
        return _this;
    }
    EdgeCreationInputMode.prototype.updateEditorProps = function (props) {
        this.editorProps = props;
    };
    EdgeCreationInputMode.prototype.onEdgeCreated = function (evt) {
        _super.prototype.onEdgeCreated.call(this, evt);
        // get depending objects
        var edge = evt.item;
        var sourceNode = evt.sourcePortOwner;
        var targetNode = evt.targetPortOwner;
        var sourceMapObject = sourceNode.tag;
        var targetMapObject = targetNode.tag;
        var bends = '';
        edge.bends.forEach(function (bend) {
            if (bends.length > 0) {
                bends += ';';
            }
            bends += parseInt(bend.location.x.toString()) + ',' + parseInt(bend.location.y.toString());
        });
        // create map connection object
        var connection = {
            mapconnection_id: -1,
            source_shd_map_mapobject__id: sourceMapObject.mapobject_id,
            target_shd_map_mapobject__id: targetMapObject.mapobject_id,
            textvisible: '0',
            title: '',
            bends: bends,
            sourcearrowtype: this.editorProps.source_arrow_type.toString(),
            targetarrowtype: this.editorProps.target_arrow_type.toString(),
            linecolor: this.editorProps.line_color,
            linewidth: this.editorProps.stroke.toString(),
            linestyle: this.editorProps.style.toString(),
            realizertype: ''
        };
        // assign map connection object to edge
        edge.tag = connection;
        // set edge style based on map connection object (to avoid using default edge style)
        this.apiProps.graph_component.graph.setStyle(edge, EdgeStyleSettings_1.EdgeStyleSettings.getEdgeStyle(connection));
        // save new edge
        (0, ajax_1.api)('shd.map_connection.create', __assign({ shd_map__id: this.apiProps.map_id }, connection), this.apiProps).then(function (res) {
            // save map connection ID
            connection.mapconnection_id = parseInt(res.result.response);
            edge.tag = connection;
        });
    };
    return EdgeCreationInputMode;
}(yfiles_1.CreateEdgeInputMode));
exports.EdgeCreationInputMode = EdgeCreationInputMode;


/***/ }),

/***/ "oqoH":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EdgeEditorInputMode = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var ajax_1 = __webpack_require__("qrt2");
var yfiles_1 = __webpack_require__("GsAs");
var EdgeCreationInputMode_1 = __webpack_require__("m9v7");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var EdgeMovingInputMode_1 = __webpack_require__("/uOu");
var EdgeEditorInputMode = /** @class */ (function (_super) {
    __extends(EdgeEditorInputMode, _super);
    function EdgeEditorInputMode(apiProps, onLeftClick, editorProps) {
        var _this = _super.call(this, {
            clickableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.EDGE_LABEL | view_component_1.GraphItemTypes.BEND,
            clickSelectableItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.EDGE_LABEL | view_component_1.GraphItemTypes.BEND,
            createEdgeInputMode: new EdgeCreationInputMode_1.EdgeCreationInputMode(apiProps, editorProps),
            moveInputMode: new EdgeMovingInputMode_1.EdgeMovingInputMode(apiProps),
            focusableItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.NODE_LABEL,
            selectableItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.EDGE_LABEL | view_component_1.GraphItemTypes.BEND,
            showHandleItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.EDGE_LABEL,
            marqueeSelectableItems: view_component_1.GraphItemTypes.NONE,
            movableItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.EDGE_LABEL | view_component_1.GraphItemTypes.BEND,
            deletableItems: view_component_1.GraphItemTypes.EDGE | view_component_1.GraphItemTypes.BEND,
            labelEditableItems: view_component_1.GraphItemTypes.LABEL_OWNER | view_component_1.GraphItemTypes.LABEL | view_component_1.GraphItemTypes.EDGE,
            allowClipboardOperations: false,
            allowGroupingOperations: false,
            allowDuplicate: false,
            allowAddLabel: true,
            allowEditLabel: true,
            allowCreateNode: false,
            allowCreateEdge: true,
            allowCreateBend: true
        }) || this;
        _this.apiProps = apiProps;
        _this.editorProps = editorProps;
        _this.onLeftClick = onLeftClick;
        return _this;
    }
    EdgeEditorInputMode.prototype.updateEditorProps = function (props) {
        this.editorProps = props;
        var mode = this.createEdgeInputMode;
        mode.updateEditorProps(props);
    };
    EdgeEditorInputMode.prototype.updateSelectedEdges = function (props) {
        var _this = this;
        if (this.apiProps.graph_component.selection.selectedEdges.size <= 0) {
            return;
        }
        this.apiProps.graph_component.selection.selectedEdges.forEach(function (edge) {
            var connection = edge.tag;
            connection.linewidth = props.stroke.toString();
            connection.linestyle = props.style.toString();
            connection.linecolor = props.line_color;
            connection.sourcearrowtype = props.source_arrow_type.toString();
            connection.targetarrowtype = props.target_arrow_type.toString();
            edge.tag = connection;
            // repaint edge
            _this.apiProps.graph_component.graph.setStyle(edge, EdgeStyleSettings_1.EdgeStyleSettings.getEdgeStyle(connection));
            // update edge
            (0, ajax_1.api)('shd.map_connection.update', __assign({ mapconnection_id: connection.mapconnection_id }, connection), _this.apiProps).then(function () {
            });
        });
    };
    EdgeEditorInputMode.prototype.onItemLeftClicked = function (evt) {
        _super.prototype.onItemLeftClicked.call(this, evt);
        if (!evt.item.tag || !('mapconnection_id' in evt.item.tag)) {
            // clicked object is not an edge
            return;
        }
        // load edge settings
        var connection = evt.item.tag;
        var edgeSetup = EdgeStyleSettings_1.EdgeStyleSettings.getEdgeSetupByMapConnection(connection);
        // update global edge setup with these settings
        this.onLeftClick(edgeSetup);
    };
    EdgeEditorInputMode.prototype.onPortAdded = function (evt) {
        console.debug('on port added');
    };
    EdgeEditorInputMode.prototype.deleteSelection = function () {
        var _this = this;
        this.graphComponent.selection.selectedEdges.forEach(function (edge) {
            var mapConnection = edge.tag;
            (0, ajax_1.api)('shd.map_connection.delete', {
                mapconnection_id: mapConnection.mapconnection_id
            }, _this.apiProps).then(function () {
                console.debug('edge successful deleted');
            });
        });
        _super.prototype.deleteSelection.call(this);
    };
    return EdgeEditorInputMode;
}(yfiles_1.GraphEditorInputMode));
exports.EdgeEditorInputMode = EdgeEditorInputMode;


/***/ }),

/***/ "/uOu":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EdgeMovingInputMode = void 0;
var yfiles_1 = __webpack_require__("GsAs");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var ajax_1 = __webpack_require__("qrt2");
var EdgeMovingInputMode = /** @class */ (function (_super) {
    __extends(EdgeMovingInputMode, _super);
    function EdgeMovingInputMode(apiProps) {
        var _this = _super.call(this) || this;
        _this.enabled = true;
        _this.apiProps = apiProps;
        return _this;
    }
    EdgeMovingInputMode.prototype.onDragFinished = function (evt) {
        var _this = this;
        _super.prototype.onDragFinished.call(this, evt);
        if (this.apiProps.graph_component.selection.selectedEdges.size <= 0) {
            return;
        }
        this.apiProps.graph_component.selection.selectedEdges.forEach(function (edge) {
            var bends = '';
            edge.bends.forEach(function (bend) {
                if (bends.length > 0) {
                    bends += ';';
                }
                bends += parseInt(bend.location.x.toString()) + ',' + parseInt(bend.location.y.toString());
            });
            var connection = edge.tag;
            connection.bends = bends;
            // assign map connection object to edge
            edge.tag = connection;
            // set edge style based on map connection object (to avoid using default edge style)
            _this.apiProps.graph_component.graph.setStyle(edge, EdgeStyleSettings_1.EdgeStyleSettings.getEdgeStyle(connection));
            // update edge
            (0, ajax_1.api)('shd.map_connection.update', {
                mapconnection_id: connection.mapconnection_id,
                bends: bends
            }, _this.apiProps).then(function () {
            });
        });
    };
    return EdgeMovingInputMode;
}(yfiles_1.MoveInputMode));
exports.EdgeMovingInputMode = EdgeMovingInputMode;


/***/ }),

/***/ "j1fJ":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.LabelPositionInputMode = void 0;
var yfiles_1 = __webpack_require__("GsAs");
var ajax_1 = __webpack_require__("qrt2");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var LabelPositionInputMode = /** @class */ (function (_super) {
    __extends(LabelPositionInputMode, _super);
    function LabelPositionInputMode(apiProps) {
        var _this = _super.call(this) || this;
        _this.enabled = true;
        _this.apiProps = apiProps;
        return _this;
    }
    LabelPositionInputMode.prototype.onDragFinished = function (evt) {
        _super.prototype.onDragFinished.call(this, evt);
        var label = this.apiProps.graph_component.selection.selectedLabels.first();
        var node = label.owner;
        var labelGeometry = label.layoutParameter.model.getGeometry(label, label.layoutParameter);
        var modelPosition = NodeStyleSettings_1.NodeStyleSettings.getLabelPosition(node.layout.center, labelGeometry.orientedRectangleCenter);
        var position = NodeStyleSettings_1.NodeStyleSettings.getIndexOfPosition(modelPosition);
        var mapObject = node.tag;
        mapObject.labelposition = position.toString();
        // assign map object object to node
        node.tag = mapObject;
        // update node
        (0, ajax_1.api)('shd.map_object.update', {
            mapobject_id: mapObject.mapobject_id,
            labelposition: position
        }, this.apiProps).then(function () {
        });
    };
    return LabelPositionInputMode;
}(yfiles_1.MoveLabelInputMode));
exports.LabelPositionInputMode = LabelPositionInputMode;


/***/ }),

/***/ "apmn":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NodeEditorInputMode = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var ajax_1 = __webpack_require__("qrt2");
var yfiles_1 = __webpack_require__("GsAs");
var ChangeNodeSizeInputMode_1 = __webpack_require__("MnP8");
var ChangeNodePositionInputMode_1 = __webpack_require__("bisk");
var LabelPositionInputMode_1 = __webpack_require__("j1fJ");
var ShapeNodeStyle_1 = __webpack_require__("Ms6H");
var ImageNodeStyle_1 = __webpack_require__("WrRr");
var TextNodeStyle_1 = __webpack_require__("v4wb");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var NodeEditorInputMode = /** @class */ (function (_super) {
    __extends(NodeEditorInputMode, _super);
    function NodeEditorInputMode(apiProps, editorProps, onLeftClick) {
        var _this = _super.call(this, {
            clickableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            clickSelectableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            // clickInputMode: new HighlightClickInputMode(graphComponent, 0),
            focusableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            selectableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            showHandleItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            marqueeSelectableItems: view_component_1.GraphItemTypes.NONE,
            movableItems: view_component_1.GraphItemTypes.NODE | view_component_1.GraphItemTypes.NODE_LABEL,
            moveInputMode: new ChangeNodePositionInputMode_1.ChangeNodePositionInputMode(apiProps),
            handleInputMode: new ChangeNodeSizeInputMode_1.ChangeNodeSizeInputMode(apiProps),
            deletableItems: view_component_1.GraphItemTypes.NODE,
            // labelDropInputMode : LabelDropInputMode
            labelEditableItems: view_component_1.GraphItemTypes.LABEL_OWNER | view_component_1.GraphItemTypes.LABEL | view_component_1.GraphItemTypes.NODE,
            moveLabelInputMode: new LabelPositionInputMode_1.LabelPositionInputMode(apiProps),
            // nodeDropInputMode : DropInputMode('text/json'),
            allowClipboardOperations: false,
            allowGroupingOperations: false,
            allowDuplicate: false,
            allowAddLabel: true,
            allowEditLabel: true,
            allowCreateNode: false,
            allowCreateEdge: false,
            allowCreateBend: false
        }) || this;
        _this.apiProps = apiProps;
        _this.editorProps = editorProps;
        _this.onLeftClick = onLeftClick;
        return _this;
    }
    NodeEditorInputMode.prototype.allowNodeCreation = function (allow) {
        this.allowCreateNode = allow;
    };
    NodeEditorInputMode.prototype.updateNodeSetup = function (props) {
        this.editorProps.node_setup = props;
    };
    NodeEditorInputMode.prototype.setStructureView = function (structureView) {
        this.structureView = structureView;
    };
    NodeEditorInputMode.prototype.updateStructureView = function () {
        if (this.structureView) {
            this.structureView.buildStructure();
        }
    };
    NodeEditorInputMode.prototype.updateSelectedNodes = function (props) {
        var _this = this;
        if (this.apiProps.graph_component.selection.selectedNodes.size <= 0) {
            return;
        }
        this.apiProps.graph_component.selection.selectedNodes.forEach(function (node) {
            var data = node.tag;
            console.debug('change font of selected node: ' + data.title);
            data.font = NodeStyleSettings_1.NodeStyleSettings.getFontStringByNodeSetup(props);
            data.textcolor = props.color;
            data.fillcolor = props.background_color;
            if (data.realizertype == '1') {
                data.shapetype = props.shape_type.toString();
            }
            node.tag = data;
            // repaint node
            _this.apiProps.graph_component.graph.setStyle(node, NodeStyleSettings_1.NodeStyleSettings.getNodeStyle(data, _this.editorProps.base_url));
            // update node
            (0, ajax_1.api)('shd.map_object.update', {
                mapobject_id: data.mapobject_id,
                font: data.font,
                textcolor: data.textcolor,
                fillcolor: data.fillcolor,
                shapetype: data.shapetype
            }, _this.apiProps).then(function () {
            });
        });
    };
    NodeEditorInputMode.prototype.onItemLeftClicked = function (evt) {
        _super.prototype.onItemLeftClicked.call(this, evt);
        if (!evt.item.tag || !('mapobject_id' in evt.item.tag)) {
            // clicked object is not a node
            return;
        }
        // load node settings
        var mapObject = evt.item.tag;
        var nodeSetup = NodeStyleSettings_1.NodeStyleSettings.getNodeSetupByMapObject(mapObject);
        if (!nodeSetup) {
            return;
        }
        // update global edge setup with these settings
        this.onLeftClick(nodeSetup);
    };
    NodeEditorInputMode.prototype.onLabelTextEdited = function (label, text) {
        var _this = this;
        return _super.prototype.onLabelTextEdited.call(this, label, text).then(function (res) {
            var mapObject = label.owner.tag;
            var textVisible = text.length > 0;
            (0, ajax_1.api)('shd.map_object.update', {
                mapobject_id: mapObject.mapobject_id,
                title: text,
                is_title_custom: true,
                textvisible: textVisible
            }, _this.apiProps).then(function () {
                _this.updateStructureView();
            });
            return res;
        });
    };
    NodeEditorInputMode.prototype.onLabelAdded = function (evt) {
        console.debug('on label added');
    };
    NodeEditorInputMode.prototype.onNodeCreated = function (evt) {
        _super.prototype.onNodeCreated.call(this, evt);
        // setup new text node
        evt.item.tag = {
            fillcolor: '#FFFFFF',
            title: 'Text'
        };
        this.setupNewNode(evt.item);
    };
    NodeEditorInputMode.prototype.setupNewNode = function (node) {
        var _this = this;
        // note: if the node has already a tag, it was dropped on the map
        // otherwise it was created by a click on the map
        var realizertype = 0;
        var defaults = node.tag;
        var title = defaults && defaults.title ? defaults.title : 'New Node';
        var labelLineColor = null;
        // get settings of current style
        var style = null;
        if (this.graphComponent.graph.nodeDefaults.style instanceof ShapeNodeStyle_1.MyShapeNodeStyle) {
            realizertype = 1; // or 2
            style = new ShapeNodeStyle_1.MyShapeNodeStyle();
            title = '';
        }
        if (this.graphComponent.graph.nodeDefaults.style instanceof TextNodeStyle_1.TextNodeStyle) {
            realizertype = 1;
            style = new TextNodeStyle_1.TextNodeStyle();
        }
        if (this.graphComponent.graph.nodeDefaults.style instanceof ImageNodeStyle_1.MyImageNodeStyle) {
            realizertype = 0;
            style = new ImageNodeStyle_1.MyImageNodeStyle(this.editorProps.base_url);
            labelLineColor = '#444444';
        }
        // get label position
        var labelPosition = NodeStyleSettings_1.NodeStyleSettings.getIndexOfPosition(view_component_1.ExteriorLabelModelPosition.SOUTH);
        var x = node.layout.x + (node.layout.width / 2);
        var y = node.layout.y + (node.layout.height / 2);
        var position = parseInt(x.toString()) + ',' + parseInt(y.toString());
        var font = NodeStyleSettings_1.NodeStyleSettings.getFontStringByNodeSetup(this.editorProps.node_setup);
        var textvisible = defaults && defaults.textvisible ? defaults.textvisible : '1';
        var object = {
            mapobject_id: -1,
            position: position,
            width: defaults && defaults.width ? defaults.width : node.layout.width.toString(),
            height: defaults && defaults.height ? defaults.height : node.layout.height.toString(),
            title: title,
            realizertype: realizertype.toString(),
            shapetype: defaults && defaults.shapetype ? defaults.shapetype : 0,
            labelposition: labelPosition.toString(),
            textvisible: textvisible,
            textcolor: this.editorProps.node_setup.color,
            linecolor: '#444444',
            labellinecolor: labelLineColor,
            fillcolor: defaults && defaults.fillcolor ? defaults.fillcolor : this.editorProps.node_setup.background_color,
            font: font,
            is_title_custom: '1',
            imagepath: defaults && defaults.imagepath ? defaults.imagepath : null,
            image_file: defaults && defaults.image_file ? defaults.image_file : null,
            link: defaults && defaults.link ? defaults.link : null,
            isys_obj__id: defaults && defaults.isys_obj__id ? defaults.isys_obj__id : null
        };
        // assign map connection object to edge
        node.tag = object;
        // set node style based on map object (to avoid using default node style)
        this.graphComponent.graph.setStyle(node, style);
        if (textvisible == '1') {
            this.graphComponent.graph.addLabel(node, title);
        }
        // save new node
        (0, ajax_1.api)('shd.map_object.create', __assign({ shd_map__id: this.apiProps.map_id }, object), this.apiProps).then(function (res) {
            // save map connection ID
            object.mapobject_id = parseInt(res.result.response);
            node.tag = object;
            _this.updateStructureView();
        });
    };
    NodeEditorInputMode.prototype.deleteSelection = function () {
        var _this = this;
        this.graphComponent.selection.selectedNodes.forEach(function (node) {
            // delete connected edges
            node.ports.forEach(function (port) {
                var edges = _this.graphComponent.graph.edgesAt(port);
                edges.forEach(function (edge) {
                    var mapConnection = edge.tag;
                    (0, ajax_1.api)('shd.map_connection.delete', { mapconnection_id: mapConnection.mapconnection_id }, _this.apiProps).then(function () { });
                });
            });
            // delete node
            var mapObject = node.tag;
            (0, ajax_1.api)('shd.map_object.delete', { mapobject_id: mapObject.mapobject_id }, _this.apiProps).then(function () {
                _this.updateStructureView();
            });
        });
        _super.prototype.deleteSelection.call(this);
    };
    return NodeEditorInputMode;
}(yfiles_1.GraphEditorInputMode));
exports.NodeEditorInputMode = NodeEditorInputMode;


/***/ }),

/***/ "3If0":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CmdbObjectMenu = void 0;
var React = __webpack_require__("q1tI");
var ajax_1 = __webpack_require__("qrt2");
var CmdbObjectMenu = /** @class */ (function (_super) {
    __extends(CmdbObjectMenu, _super);
    function CmdbObjectMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.handleObjectTypeChange = _this.handleObjectTypeChange.bind(_this);
        _this.handleDragStart = _this.handleDragStart.bind(_this);
        _this.handleFilterChange = _this.handleFilterChange.bind(_this);
        _this.state = {
            selected_object_type: -1,
            objects: {},
            is_loading: false,
            filter: '',
            filtered_items: {}
        };
        return _this;
    }
    CmdbObjectMenu.prototype.handleObjectTypeChange = function (evt) {
        var _this = this;
        var object_type = parseInt(evt.currentTarget.value);
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { selected_object_type: object_type, filter: '', is_loading: true })); });
        (0, ajax_1.api)('shd.query.read', {
            obj_type_id: object_type,
            columns: [
                { id: 'C__CATG__GLOBAL-title' },
                { id: 'C__CATG__GLOBAL-cmdb_status' },
                { id: 'C__CATG__GLOBAL-created' },
                { id: 'C__CATG__GLOBAL-changed' }
            ]
        }, this.props.api_props).then(function (res) {
            var objects = {};
            for (var key in res.result.content) {
                if (res.result.content.hasOwnProperty(key)) {
                    var object = res.result.content[key];
                    var id = parseInt(object.__id__);
                    objects[id] = {
                        id: id,
                        title: object['C__CATG__GLOBAL-title'],
                        status: object['C__CATG__GLOBAL-cmdb_status'],
                        created: object['C__CATG__GLOBAL-created'],
                        changed: object['C__CATG__GLOBAL-changed'],
                        object_type: object_type
                    };
                }
            }
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { objects: objects, filtered_items: objects, is_loading: false })); });
        });
    };
    CmdbObjectMenu.prototype.handleDragStart = function (evt) {
        var id = evt.target.id;
        var object = this.state.objects[id];
        var objectType = this.props.object_types[object.object_type];
        var transfer = {
            transfer_type: 'cmdb-object',
            object_id: parseInt(id),
            object_title: object.title,
            icon: objectType.icon
        };
        evt.dataTransfer.setData('text/json', JSON.stringify(transfer));
    };
    CmdbObjectMenu.prototype.handleFilterChange = function (evt) {
        var filter = evt.currentTarget.value;
        var filteredItems = {};
        if (filter != '') {
            for (var key in this.state.objects) {
                if (this.state.objects.hasOwnProperty(key)) {
                    var object = this.state.objects[key];
                    var title = object.title.toLowerCase();
                    if (title.includes(filter.toLowerCase())) {
                        filteredItems[key] = object;
                    }
                }
            }
        }
        else {
            filteredItems = this.state.objects;
        }
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { filter: filter, filtered_items: filteredItems })); });
    };
    CmdbObjectMenu.prototype.render = function () {
        var _this = this;
        var types = [];
        for (var key in this.props.object_types) {
            if (this.props.object_types.hasOwnProperty(key)) {
                types.push(this.props.object_types[key]);
            }
        }
        types.sort(function (a, b) {
            return ('' + a.title.toLowerCase()).localeCompare(b.title.toLowerCase());
        });
        var objectTypes = [React.createElement("option", { key: -1, value: -1 }, "-")];
        types.forEach(function (objectType) {
            objectTypes.push(React.createElement("option", { key: objectType.id, value: objectType.id }, objectType.title));
        });
        var objects = [];
        if (this.state.is_loading) {
            var spinnerUrl = this.props.base_url + '/images/ajax-loading.gif';
            objects.push(React.createElement("tr", { key: "loading" },
                React.createElement("td", { colSpan: 5 },
                    React.createElement("img", { src: spinnerUrl, alt: "..." }))));
        }
        else {
            var count_1 = 0;
            // sort filtered items
            var items = [];
            for (var key in this.state.filtered_items) {
                if (this.state.filtered_items.hasOwnProperty(key)) {
                    var object = this.state.filtered_items[key];
                    items.push(object);
                }
            }
            items.sort(function (a, b) {
                return ('' + a.title.toLowerCase()).localeCompare(b.title.toLowerCase());
            });
            items.forEach(function (object) {
                count_1++;
                if (count_1 > 10) {
                    return;
                }
                // const object = this.state.filtered_items[key]
                objects.push(React.createElement("tr", { key: object.id, id: object.id.toString(), draggable: true, onDragStart: _this.handleDragStart },
                    React.createElement("td", null,
                        React.createElement("span", { className: "icon", id: object.id.toString(), draggable: true, onDragStart: _this.handleDragStart, title: _this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__DRAG_HINT }, "+")),
                    React.createElement("td", null, object.title),
                    React.createElement("td", null, object.status),
                    React.createElement("td", null, object.created),
                    React.createElement("td", null, object.changed)));
                if (count_1 == 10) {
                    objects.push(React.createElement("tr", { key: "more_objects" },
                        React.createElement("td", { colSpan: 5 }, _this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__MORE_THAN_25_OBJECTS)));
                }
            });
            if (Object.keys(this.state.objects).length == 0) {
                objects.push(React.createElement("tr", { key: "no_objects" },
                    React.createElement("td", { colSpan: 5 }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__OBJECT_TYPE_CONTAINS_NO_OBJECTS)));
            }
        }
        return React.createElement("div", { className: "tools-menu cmdb-object-menu" },
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__OBJECT_TYPE,
                    ":"),
                React.createElement("select", { value: this.state.selected_object_type, onChange: this.handleObjectTypeChange, className: "input input-small" }, objectTypes)),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FILTER,
                    ":"),
                React.createElement("input", { type: "text", value: this.state.filter, onChange: this.handleFilterChange, className: "input input-small" })),
            React.createElement("div", null,
                React.createElement("table", { className: "mainTable" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null, "\u00A0"),
                            React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__DESCRIPTION),
                            React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__STATUS),
                            React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__CREATED),
                            React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__CHANGED))),
                    React.createElement("tbody", null, objects))));
    };
    return CmdbObjectMenu;
}(React.Component));
exports.CmdbObjectMenu = CmdbObjectMenu;


/***/ }),

/***/ "h609":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EdgeMenu = void 0;
var React = __webpack_require__("q1tI");
var EdgeStyleSettings_1 = __webpack_require__("t09L");
var EdgeMenu = /** @class */ (function (_super) {
    __extends(EdgeMenu, _super);
    function EdgeMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.handleStrokeChange = _this.handleStrokeChange.bind(_this);
        _this.handleStyleChange = _this.handleStyleChange.bind(_this);
        _this.handleSourceArrowChange = _this.handleSourceArrowChange.bind(_this);
        _this.handleTargetArrowChange = _this.handleTargetArrowChange.bind(_this);
        _this.handleLineColorChange = _this.handleLineColorChange.bind(_this);
        return _this;
    }
    EdgeMenu.prototype.handleStrokeChange = function (evt) {
        var edgeSetup = this.props.edge_setup;
        edgeSetup.stroke = parseInt(evt.currentTarget.value);
        this.props.onEdgeSetupChange(edgeSetup, true);
    };
    EdgeMenu.prototype.handleStyleChange = function (evt) {
        var edgeSetup = this.props.edge_setup;
        edgeSetup.style = parseInt(evt.currentTarget.value);
        this.props.onEdgeSetupChange(edgeSetup, true);
    };
    EdgeMenu.prototype.handleSourceArrowChange = function (evt) {
        var edgeSetup = this.props.edge_setup;
        edgeSetup.source_arrow_type = parseInt(evt.currentTarget.value);
        this.props.onEdgeSetupChange(edgeSetup, true);
    };
    EdgeMenu.prototype.handleTargetArrowChange = function (evt) {
        var edgeSetup = this.props.edge_setup;
        edgeSetup.target_arrow_type = parseInt(evt.currentTarget.value);
        this.props.onEdgeSetupChange(edgeSetup, true);
    };
    EdgeMenu.prototype.handleLineColorChange = function (evt) {
        var edgeSetup = this.props.edge_setup;
        edgeSetup.line_color = evt.currentTarget.value;
        this.props.onEdgeSetupChange(edgeSetup, true);
    };
    EdgeMenu.prototype.render = function () {
        var lineStrokes = [];
        for (var className in EdgeMenu.LINE_STROKES) {
            if (EdgeMenu.LINE_STROKES.hasOwnProperty(className)) {
                var edge = EdgeMenu.LINE_STROKES[className];
                lineStrokes.push(React.createElement("input", { type: "radio", name: "edge_stroke[]", key: 'stroke_' + edge, checked: this.props.edge_setup.stroke == edge, onChange: this.handleStrokeChange, value: edge }));
                lineStrokes.push(React.createElement("span", { key: 'shape_stroke_' + edge, className: 'shape ' + className }));
            }
        }
        var lineTypes = [];
        for (var className in EdgeMenu.LINE_TYPES) {
            if (EdgeMenu.LINE_TYPES.hasOwnProperty(className)) {
                var edge = EdgeMenu.LINE_TYPES[className];
                lineTypes.push(React.createElement("input", { type: "radio", name: "edge_style[]", key: 'style_' + edge, checked: this.props.edge_setup.style == edge, onChange: this.handleStyleChange, value: edge }));
                lineTypes.push(React.createElement("span", { key: 'shape_style_' + edge, className: 'shape ' + className }));
            }
        }
        var sourceArrows = [];
        var targetArrows = [];
        for (var className in EdgeMenu.ARROWS) {
            if (EdgeMenu.ARROWS.hasOwnProperty(className)) {
                var arrow = EdgeMenu.ARROWS[className];
                sourceArrows.push(React.createElement("input", { type: "radio", name: "source_arrow[]", key: 'source_' + arrow, checked: this.props.edge_setup.source_arrow_type == arrow, onChange: this.handleSourceArrowChange, value: arrow }));
                sourceArrows.push(React.createElement("span", { key: 'shape_source_' + arrow, className: 'shape ' + className }));
                targetArrows.push(React.createElement("input", { type: "radio", name: "target_arrow[]", key: 'target_' + arrow, checked: this.props.edge_setup.target_arrow_type == arrow, onChange: this.handleTargetArrowChange, value: arrow }));
                targetArrows.push(React.createElement("span", { key: 'shape_target_' + arrow, className: 'shape rotate-180 ' + className }));
            }
        }
        return React.createElement("div", { className: "tools-menu edge-menu" },
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__STROKE,
                    ":"),
                lineStrokes),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__STYLE,
                    ":"),
                lineTypes),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__SOURCE_ARROW,
                    ":"),
                sourceArrows),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__TARGET_ARROW,
                    ":"),
                targetArrows),
            React.createElement("div", { className: "color-picker" },
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__LINE_COLOR,
                    ":"),
                React.createElement("input", { key: "color", type: "color", onChange: this.handleLineColorChange, value: this.props.edge_setup.line_color })));
    };
    EdgeMenu.LINE_STROKES = {
        'shape-line-xs': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_XS,
        'shape-line-s': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_S,
        'shape-line-m': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_M,
        'shape-line-l': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_L,
        'shape-line-xl': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STROKE_XL
    };
    EdgeMenu.LINE_TYPES = {
        'shape-line-s': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STYLE_SOLID,
        'shape-line-dotted': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STYLE_DOTTED,
        'shape-line-dashed': EdgeStyleSettings_1.EdgeStyleSettings.EDGE_STYLE_DASHED
    };
    EdgeMenu.ARROWS = {
        'shape-arrow-none': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_NONE,
        'shape-arrow-default': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_DEFAULT,
        'shape-arrow-circle': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_CIRCLE,
        'shape-arrow-diamond': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_DIAMOND,
        'shape-arrow-short': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_SHORT,
        'shape-arrow-triangle': EdgeStyleSettings_1.EdgeStyleSettings.ARROW_TYPE_TRIANGLE
    };
    return EdgeMenu;
}(React.Component));
exports.EdgeMenu = EdgeMenu;


/***/ }),

/***/ "DDrO":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ImageMenu = void 0;
var React = __webpack_require__("q1tI");
var ajax_1 = __webpack_require__("qrt2");
var ImageMenu = /** @class */ (function (_super) {
    __extends(ImageMenu, _super);
    function ImageMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.loadDirectory = _this.loadDirectory.bind(_this);
        _this.handleLoadDirectory = _this.handleLoadDirectory.bind(_this);
        _this.handleImagePreview = _this.handleImagePreview.bind(_this);
        _this.handleDragStart = _this.handleDragStart.bind(_this);
        _this.getPreview = _this.getPreview.bind(_this);
        _this.state = {
            selected_path: '',
            paths: {},
            images: {},
            is_loading: false,
            is_image_loading: false
        };
        return _this;
    }
    ImageMenu.prototype.componentDidMount = function () {
        this.loadDirectory('/');
    };
    ImageMenu.prototype.loadDirectory = function (directory) {
        var _this = this;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { selected_path: directory, is_loading: true })); });
        var currentPath = directory;
        (0, ajax_1.api)('shd.file.dir', { path: currentPath }, this.props.api_props).then(function (res) {
            var images = [];
            var paths = _this.state.paths;
            paths[currentPath] = [];
            for (var key in res.result) {
                if (res.result.hasOwnProperty(key)) {
                    var image = res.result[key];
                    if (image.type == 'd') {
                        paths[currentPath].push(image.name);
                    }
                    if (image.type == 'f') {
                        images.push({
                            hash: image.hash,
                            path: image.path != '' ? image.path : '/',
                            title: image.name
                        });
                    }
                }
            }
            var allImages = _this.state.images;
            allImages[currentPath] = images;
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { paths: paths, images: allImages })); });
        }).finally(function () {
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { is_loading: false })); });
        });
    };
    ImageMenu.prototype.handleLoadDirectory = function (evt) {
        var path = evt.currentTarget.id;
        this.loadDirectory(path);
    };
    ImageMenu.prototype.handleImagePreview = function (evt) {
        var _this = this;
        // get selected image
        var hash = evt.currentTarget.id;
        var image = null;
        for (var path in this.state.images) {
            if (this.state.images.hasOwnProperty(path)) {
                var images = this.state.images[path];
                images.forEach(function (img) {
                    if (img.hash == hash) {
                        image = img;
                    }
                });
            }
        }
        if (!image) {
            return;
        }
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { selected_image: image, is_image_loading: true })); });
        (0, ajax_1.api)('maps.image.read', {
            path: image.path + (image.path == '/' ? '' : '/') + image.title,
            include_file: 1
        }, this.props.api_props).then(function (res) {
            var data = res.result.content;
            var object = _this.state.selected_image;
            object.data = data;
            object.width = res.result.width;
            object.height = res.result.height;
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { selected_image: object })); });
        }).finally(function () {
            _this.setState(function (prevState) { return (__assign(__assign({}, prevState), { is_image_loading: false })); });
        });
    };
    ImageMenu.prototype.handleDragStart = function (evt) {
        var object = this.state.selected_image;
        var path = object.path + (object.path != '/' ? '/' : '') + object.title;
        var transfer = {
            transfer_type: 'image',
            object_id: 0,
            object_title: path,
            icon: this.state.selected_image.data,
            image_width: this.state.selected_image.width,
            image_height: this.state.selected_image.height
        };
        evt.dataTransfer.setData('text/json', JSON.stringify(transfer));
    };
    ImageMenu.prototype.getPreview = function () {
        if (!(this.state.selected_image && this.state.selected_image.data) && !this.state.is_image_loading) {
            return null;
        }
        var spinnerUrl = this.props.base_url + '/images/ajax-loading.gif';
        var img = null;
        var info = null;
        if (this.state.selected_image && this.state.selected_image.data) {
            img = React.createElement("img", { src: 'data:image/png;base64, ' + this.state.selected_image.data, alt: this.state.selected_image.title, title: this.state.selected_image.title, id: this.state.selected_image.title, draggable: true, onDragStart: this.handleDragStart });
            info = React.createElement("span", null,
                this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__IMAGE_SIZE,
                ":\u00A0",
                this.state.selected_image.width + ' x ' + this.state.selected_image.height + ' px');
        }
        if (this.state.is_image_loading) {
            img = React.createElement("img", { src: spinnerUrl, alt: "..." });
        }
        return React.createElement("ol", { key: "preview", className: "preview" },
            React.createElement("li", null,
                img,
                info));
    };
    ImageMenu.prototype.render = function () {
        var _this = this;
        var ols = [];
        if (this.state.is_loading) {
            var spinnerUrl = this.props.base_url + '/images/ajax-loading.gif';
            ols.push(React.createElement("ol", { key: "loading" },
                React.createElement("li", { key: "loading" },
                    React.createElement("img", { src: spinnerUrl, alt: "..." }))));
        }
        else {
            var sp = this.state.selected_path.substr(1);
            var selectedPath = sp.split('/');
            selectedPath.unshift('/'); // add root directory
            var currentPath_1 = '';
            selectedPath.forEach(function (dir) {
                if (dir == '') {
                    return;
                }
                currentPath_1 += dir;
                var paths = _this.state.paths[currentPath_1] ? _this.state.paths[currentPath_1] : [];
                var images = _this.state.images[currentPath_1] ? _this.state.images[currentPath_1] : [];
                currentPath_1 += dir == '/' ? '' : '/'; // add trailing slash
                var dirItems = [];
                paths.forEach(function (path) {
                    var completePath = currentPath_1 + path;
                    var className = 'dir ';
                    className += _this.state.selected_path.startsWith(completePath) ? 'selected' : '';
                    dirItems.push(React.createElement("li", { key: completePath },
                        React.createElement("button", { id: completePath, type: "button", className: className, onClick: _this.handleLoadDirectory }, path)));
                });
                images.forEach(function (image) {
                    var className = 'image ';
                    className += _this.state.selected_image && image.hash == _this.state.selected_image.hash ? 'selected' : '';
                    dirItems.push(React.createElement("li", { key: image.hash, id: image.hash },
                        React.createElement("button", { id: image.hash, type: "button", className: className, onClick: _this.handleImagePreview }, image.title)));
                });
                ols.push(React.createElement("ol", { key: currentPath_1 }, dirItems));
            });
        }
        return React.createElement("div", { className: "tools-menu image-menu" },
            React.createElement("div", null,
                ols,
                this.getPreview()));
    };
    return ImageMenu;
}(React.Component));
exports.ImageMenu = ImageMenu;


/***/ }),

/***/ "aOeG":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MapMenu = void 0;
var React = __webpack_require__("q1tI");
var MapMenu = /** @class */ (function (_super) {
    __extends(MapMenu, _super);
    function MapMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.handleDragStart = _this.handleDragStart.bind(_this);
        _this.handleFilterChange = _this.handleFilterChange.bind(_this);
        _this.state = {
            filter: '',
            filtered_items: _this.props.maps
        };
        return _this;
    }
    MapMenu.prototype.handleDragStart = function (evt) {
        var id = evt.target.id;
        var map;
        for (var key in this.props.maps) {
            if (this.props.maps.hasOwnProperty(key)) {
                var object = this.props.maps[key];
                if (object.map_id == parseInt(id)) {
                    map = object;
                }
            }
        }
        var transfer = {
            transfer_type: 'map',
            object_id: parseInt(id),
            object_title: map.title,
            icon: 'src/classes/modules/smview_maps/theme/img/icons/network_128.png'
        };
        evt.dataTransfer.setData('text/json', JSON.stringify(transfer));
    };
    MapMenu.prototype.handleFilterChange = function (evt) {
        var filter = evt.currentTarget.value;
        var filteredItems = [];
        if (filter != '') {
            for (var key in this.props.maps) {
                if (this.props.maps.hasOwnProperty(key)) {
                    var object = this.props.maps[key];
                    var title = object.title.toLowerCase();
                    if (title.includes(filter.toLowerCase())) {
                        filteredItems.push(object);
                    }
                }
            }
        }
        else {
            filteredItems = this.props.maps;
        }
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { filter: filter, filtered_items: filteredItems })); });
    };
    MapMenu.prototype.render = function () {
        var _this = this;
        var maps = [];
        var count = 0;
        // sort filtered items
        var items = [];
        this.state.filtered_items.forEach(function (object) { items.push(object); });
        items.sort(function (a, b) {
            return ('' + a.title.toLowerCase()).localeCompare(b.title.toLowerCase());
        });
        items.forEach(function (object) {
            count++;
            if (count > 10) {
                return;
            }
            maps.push(React.createElement("tr", { key: object.map_id, id: object.map_id.toString(), draggable: true, onDragStart: _this.handleDragStart },
                React.createElement("td", null,
                    React.createElement("span", { className: "icon", id: object.map_id.toString(), draggable: true, onDragStart: _this.handleDragStart, title: _this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__DRAG_HINT }, "+")),
                React.createElement("td", null, object.title)));
            if (count == 10) {
                maps.push(React.createElement("tr", { key: "more_objects" },
                    React.createElement("td", { colSpan: 2 }, _this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__MORE_THAN_25_OBJECTS)));
            }
        });
        if (Object.keys(this.props.maps).length == 0) {
            maps.push(React.createElement("tr", { key: "no_maps" },
                React.createElement("td", { colSpan: 2 }, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__NO_MAPS)));
        }
        return React.createElement("div", { className: "tools-menu map-menu" },
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FILTER,
                    ":"),
                React.createElement("input", { type: "text", value: this.state.filter, onChange: this.handleFilterChange, className: "input input-small" })),
            React.createElement("div", null,
                React.createElement("table", { className: "mainTable" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null, "\u00A0"),
                            React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__DESCRIPTION))),
                    React.createElement("tbody", null, maps))));
    };
    return MapMenu;
}(React.Component));
exports.MapMenu = MapMenu;


/***/ }),

/***/ "I4Gm":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ShapeMenu = void 0;
var React = __webpack_require__("q1tI");
var ShapeMenu = /** @class */ (function (_super) {
    __extends(ShapeMenu, _super);
    function ShapeMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.handleDragStart = _this.handleDragStart.bind(_this);
        _this.handleShapeChange = _this.handleShapeChange.bind(_this);
        return _this;
    }
    ShapeMenu.prototype.handleDragStart = function (evt) {
        var id = parseInt(evt.target.id);
        var shape = ShapeMenu.SHAPES[id];
        var transfer = {
            transfer_type: 'shape',
            object_id: id,
            icon: shape
        };
        evt.dataTransfer.setData('text/json', JSON.stringify(transfer));
    };
    ShapeMenu.prototype.handleShapeChange = function (evt) {
        var span = evt.target;
        var nodeSetup = this.props.node_setup;
        nodeSetup.shape_type = parseInt(span.id);
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    ShapeMenu.prototype.render = function () {
        var shapes = [];
        for (var key in ShapeMenu.SHAPES) {
            if (ShapeMenu.SHAPES.hasOwnProperty(key)) {
                var shape = ShapeMenu.SHAPES[key];
                var isSelected = this.props.node_setup.shape_type && this.props.node_setup.shape_type.toString() == key;
                shapes.push(React.createElement("span", { className: 'shape ' + shape + (isSelected ? ' selected' : ''), id: key, key: key, onClick: this.handleShapeChange, draggable: true, onDragStart: this.handleDragStart }));
            }
        }
        return React.createElement("div", { className: "tools-menu shape-menu" },
            React.createElement("div", null, shapes));
    };
    ShapeMenu.SHAPES = {
        0: 'shape-rectangle',
        1: 'shape-round_rectangle',
        2: 'shape-ellipse',
        3: 'shape-rhomboid',
        4: 'shape-hexagon',
        5: 'shape-triangle',
        7: 'shape-stop_sign',
        8: 'shape-rhomb',
        9: 'shape-trapez_top',
        10: 'shape-trapez_bottom'
    };
    return ShapeMenu;
}(React.Component));
exports.ShapeMenu = ShapeMenu;


/***/ }),

/***/ "cw+J":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.TextMenu = void 0;
var React = __webpack_require__("q1tI");
var TextMenu = /** @class */ (function (_super) {
    __extends(TextMenu, _super);
    function TextMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.handleFontFamilyChange = _this.handleFontFamilyChange.bind(_this);
        _this.handleFontSizeChange = _this.handleFontSizeChange.bind(_this);
        _this.handleIsBoldChange = _this.handleIsBoldChange.bind(_this);
        _this.handleIsItalicChange = _this.handleIsItalicChange.bind(_this);
        _this.handleTextColorChange = _this.handleTextColorChange.bind(_this);
        _this.handleBackgroundColorChange = _this.handleBackgroundColorChange.bind(_this);
        return _this;
    }
    TextMenu.prototype.handleFontFamilyChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.family = evt.currentTarget.value;
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.handleFontSizeChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.size = parseInt(evt.currentTarget.value);
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.handleIsBoldChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.is_bold = evt.currentTarget.checked;
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.handleIsItalicChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.is_italic = evt.currentTarget.checked;
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.handleTextColorChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.color = evt.currentTarget.value;
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.handleBackgroundColorChange = function (evt) {
        var nodeSetup = this.props.node_setup;
        nodeSetup.background_color = evt.currentTarget.value;
        this.props.onNodeSetupChange(nodeSetup, true);
    };
    TextMenu.prototype.render = function () {
        var fonts = [];
        for (var key in TextMenu.FONTS) {
            if (TextMenu.FONTS.hasOwnProperty(key)) {
                var font = TextMenu.FONTS[key];
                fonts.push(React.createElement("option", { key: font, value: font }, font));
            }
        }
        var fontSizes = [];
        for (var key in TextMenu.FONT_SIZES) {
            if (TextMenu.FONT_SIZES.hasOwnProperty(key)) {
                var size = TextMenu.FONT_SIZES[key];
                fontSizes.push(React.createElement("option", { key: size, value: size }, size));
            }
        }
        return React.createElement("div", { className: "tools-menu text-menu" },
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FONT_STYLE,
                    ":"),
                React.createElement("select", { name: "font_family", value: this.props.node_setup.family, onChange: this.handleFontFamilyChange, className: "input input-mini" }, fonts)),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FONT_SIZE,
                    ":"),
                React.createElement("select", { name: "font_size", value: this.props.node_setup.size, onChange: this.handleFontSizeChange, className: "input input-mini" }, fontSizes)),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FONT_IS_BOLD,
                    ":"),
                React.createElement("input", { name: "is_bold", type: "checkbox", checked: this.props.node_setup.is_bold, onChange: this.handleIsBoldChange })),
            React.createElement("div", null,
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__FONT_IS_ITALIC,
                    ":"),
                React.createElement("input", { name: "is_italic", type: "checkbox", checked: this.props.node_setup.is_italic, onChange: this.handleIsItalicChange })),
            React.createElement("div", { className: "color-picker" },
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__TEXT_COLOR,
                    ":"),
                React.createElement("input", { name: "text_color", type: "color", onChange: this.handleTextColorChange, value: this.props.node_setup.color })),
            React.createElement("div", { className: "color-picker" },
                React.createElement("span", { className: "title" },
                    this.props.language.LC__CMDB__CATG__SMVIEW_MAPS__BACKGROUND_COLOR,
                    ":"),
                React.createElement("input", { name: "background_color", type: "color", onChange: this.handleBackgroundColorChange, value: this.props.node_setup.background_color })));
    };
    TextMenu.FONTS = [
        'Arial',
        'Dialog',
        'Tahoma'
    ];
    TextMenu.FONT_SIZES = [8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72, 96];
    return TextMenu;
}(React.Component));
exports.TextMenu = TextMenu;


/***/ }),

/***/ "EbKB":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AbstractNodeStyle = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var AbstractNodeStyle = /** @class */ (function (_super) {
    __extends(AbstractNodeStyle, _super);
    function AbstractNodeStyle() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AbstractNodeStyle.prototype.getRect = function (node) {
        var rect = window.document.createElementNS('http://www.w3.org/2000/svg', 'rect');
        var nodeSize = node.layout.toSize();
        var w = nodeSize.width;
        var h = nodeSize.height;
        var x = 0; // offset from node
        var y = 0; // offset from node
        rect.setAttribute('x', x.toString());
        rect.setAttribute('y', y.toString());
        rect.setAttribute('width', w.toString());
        rect.setAttribute('height', h.toString());
        // determine the color to use for the rendering
        var color = this.getNodeColor(node);
        rect.setAttribute('fill', color);
        return rect;
    };
    AbstractNodeStyle.prototype.getNodeColor = function (node) {
        return this._getColor(node, 'fillcolor', this.getDefaultFillColor());
    };
    AbstractNodeStyle.prototype.getBorderColor = function (node) {
        return this._getColor(node, 'linecolor', this.getDefaultBorderColor());
    };
    AbstractNodeStyle.prototype._getColor = function (node, property, defaultColor) {
        var data = node.tag;
        if (!data || !data[property]) {
            return defaultColor;
        }
        var value = data[property];
        if (value.length != 7) {
            // no hex value
            return defaultColor;
        }
        return value;
    };
    return AbstractNodeStyle;
}(view_component_1.NodeStyleBase));
exports.AbstractNodeStyle = AbstractNodeStyle;


/***/ }),

/***/ "t09L":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.EdgeStyleSettings = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var styles_other_1 = __webpack_require__("AuVx");
var EdgeStyleSettings = /** @class */ (function () {
    function EdgeStyleSettings() {
    }
    EdgeStyleSettings.getEdgeStyle = function (edgeData) {
        var sourceArrow = EdgeStyleSettings.getEdgeArrow(parseInt(edgeData.sourcearrowtype), parseInt(edgeData.linewidth), edgeData.linecolor);
        var targetArrow = EdgeStyleSettings.getEdgeArrow(parseInt(edgeData.targetarrowtype), parseInt(edgeData.linewidth), edgeData.linecolor);
        var stroke = EdgeStyleSettings.getEdgeStroke(parseInt(edgeData.linewidth), parseInt(edgeData.linestyle), edgeData.linecolor);
        if (edgeData.realizertype == '1') {
            var style = new styles_other_1.ArcEdgeStyle();
            style.fixedHeight = true;
            style.height = 0.25;
            style.sourceArrow = sourceArrow;
            style.targetArrow = targetArrow;
            style.stroke = stroke;
            return style;
        }
        else {
            var style = new view_component_1.PolylineEdgeStyle();
            style.sourceArrow = sourceArrow;
            style.targetArrow = targetArrow;
            style.stroke = stroke;
            return style;
        }
    };
    EdgeStyleSettings.getEdgeStroke = function (lineWidth, lineStyle, lineColor) {
        lineWidth = lineWidth || EdgeStyleSettings.EDGE_STROKE_S;
        lineStyle = lineStyle || EdgeStyleSettings.EDGE_STYLE_SOLID;
        lineColor = lineColor || EdgeStyleSettings.DEFAULT_LINE_COLOR;
        var color = lineColor;
        var stroke = new view_component_1.Stroke(color, lineWidth);
        stroke.dashStyle = EdgeStyleSettings.getLineStyle(lineStyle);
        return stroke;
    };
    EdgeStyleSettings.getEdgeArrow = function (arrowType, lineWidth, lineColor) {
        lineWidth = lineWidth || EdgeStyleSettings.EDGE_STROKE_S;
        lineColor = lineColor || EdgeStyleSettings.DEFAULT_LINE_COLOR;
        var color = lineColor;
        return new view_component_1.Arrow({
            color: color,
            scale: EdgeStyleSettings.getArrowScale(lineWidth),
            type: EdgeStyleSettings.getArrow(arrowType)
        });
    };
    EdgeStyleSettings.getArrow = function (type) {
        return EdgeStyleSettings.arrow_types[type] ? EdgeStyleSettings.arrow_types[type] : view_component_1.ArrowType.DEFAULT;
    };
    EdgeStyleSettings.getArrowScale = function (width) {
        return EdgeStyleSettings.arrow_scale[width] ? EdgeStyleSettings.arrow_scale[width] : 1.4;
    };
    EdgeStyleSettings.getLineStyle = function (style) {
        return EdgeStyleSettings.line_style[style] ? EdgeStyleSettings.line_style[style] : view_component_1.DashStyle.SOLID;
    };
    EdgeStyleSettings.getEdgeSetupByMapConnection = function (connection) {
        var edgeSetup = {
            stroke: parseInt(connection.linewidth),
            style: parseInt(connection.linestyle),
            line_color: connection.linecolor,
            source_arrow_type: parseInt(connection.sourcearrowtype),
            target_arrow_type: parseInt(connection.targetarrowtype)
        };
        return edgeSetup;
    };
    EdgeStyleSettings.DEFAULT_LINE_COLOR = '000000';
    EdgeStyleSettings.ARROW_TYPE_NONE = 1;
    EdgeStyleSettings.ARROW_TYPE_DEFAULT = 2;
    EdgeStyleSettings.ARROW_TYPE_TRIANGLE = 3;
    EdgeStyleSettings.ARROW_TYPE_DIAMOND = 5;
    EdgeStyleSettings.ARROW_TYPE_SHORT = 7;
    EdgeStyleSettings.ARROW_TYPE_CIRCLE = 11;
    EdgeStyleSettings.arrow_types = {
        1: view_component_1.ArrowType.NONE,
        2: view_component_1.ArrowType.DEFAULT,
        3: view_component_1.ArrowType.TRIANGLE,
        5: view_component_1.ArrowType.DIAMOND,
        7: view_component_1.ArrowType.SHORT,
        8: view_component_1.ArrowType.SIMPLE,
        11: view_component_1.ArrowType.CIRCLE
    };
    EdgeStyleSettings.EDGE_STROKE_XS = 1;
    EdgeStyleSettings.EDGE_STROKE_S = 2;
    EdgeStyleSettings.EDGE_STROKE_M = 3;
    EdgeStyleSettings.EDGE_STROKE_L = 4;
    EdgeStyleSettings.EDGE_STROKE_XL = 5;
    EdgeStyleSettings.arrow_scale = {
        1: 1,
        2: 1.2,
        3: 1.4,
        4: 1.6,
        5: 1.8
    };
    EdgeStyleSettings.EDGE_STYLE_SOLID = 0;
    EdgeStyleSettings.EDGE_STYLE_DASHED = 1;
    EdgeStyleSettings.EDGE_STYLE_DOTTED = 2;
    EdgeStyleSettings.line_style = {
        0: view_component_1.DashStyle.SOLID,
        1: view_component_1.DashStyle.DASH,
        2: view_component_1.DashStyle.DASH_DOT_DOT
    };
    return EdgeStyleSettings;
}());
exports.EdgeStyleSettings = EdgeStyleSettings;


/***/ }),

/***/ "ja5B":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
var yfiles_1 = __webpack_require__("GsAs");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var HtmlLabelStyle = /** @class */ (function (_super) {
    __extends(HtmlLabelStyle, _super);
    function HtmlLabelStyle(nodeSetup) {
        var _this = _super.call(this) || this;
        _this.font = new yfiles_1.Font({
            fontFamily: nodeSetup ? nodeSetup.family : 'Dialog',
            fontSize: nodeSetup ? nodeSetup.size : 14
        });
        return _this;
    }
    HtmlLabelStyle.prototype.createVisual = function (context, label) {
        var labelLayout = label.layout;
        if (label.owner.tag) {
            var data = label.owner.tag;
            this.updateFont(data);
        }
        var foreignObject = document.createElementNS('http://www.w3.org/2000/svg', 'foreignObject');
        foreignObject.setAttribute('x', '0');
        foreignObject.setAttribute('y', '0');
        var div = document.createElement('div');
        div.style.setProperty('overflow', 'hidden');
        foreignObject.setAttribute('width', "".concat(labelLayout.width));
        foreignObject.setAttribute('height', "".concat(labelLayout.height));
        div.style.setProperty('width', "".concat(labelLayout.width, "px"));
        div.style.setProperty('height', "".concat(labelLayout.height, "px"));
        div.style.setProperty('font-family', this.font.fontFamily);
        div.style.setProperty('font-size', "".concat(this.font.fontSize, "px"));
        div.style.setProperty('font-weight', "".concat(this.font.fontWeight));
        div.style.setProperty('font-style', "".concat(this.font.fontStyle));
        if (label.owner.tag) {
            var data = label.owner.tag;
            div.style.setProperty('color', data.textcolor);
            div.style.setProperty('background-color', data.fillcolor);
        }
        div.innerHTML = label.text;
        foreignObject.appendChild(div);
        // move container to correct location
        var transform = yfiles_1.LabelStyleBase.createLayoutTransform(context, label.layout, true);
        transform.applyTo(foreignObject);
        foreignObject['data-cache'] = createRenderDataCache(label, this.font);
        return new yfiles_1.SvgVisual(foreignObject);
    };
    HtmlLabelStyle.prototype.updateVisual = function (context, oldVisual, label) {
        var element = oldVisual.svgElement;
        if (element === null || element.childElementCount !== 1) {
            // re-create from scratch if this is not the case
            return this.createVisual(context, label);
        }
        // get the data with which the old visual was created
        var oldCache = element['data-cache'];
        if (label.owner.tag) {
            var data = label.owner.tag;
            this.updateFont(data);
        }
        // get the data for the new visual
        var newCache = createRenderDataCache(label, this.font);
        // update elements if they have changed
        var foreignObject = element;
        var div = foreignObject.firstElementChild;
        if (!yfiles_1.YObject.equals(oldCache.layout, newCache.layout)) {
            var labelLayout = label.layout;
            foreignObject.setAttribute('width', "".concat(labelLayout.width));
            foreignObject.setAttribute('height', "".concat(labelLayout.height));
            div.style.setProperty('width', "".concat(labelLayout.width, "px"));
            div.style.setProperty('height', "".concat(labelLayout.height, "px"));
        }
        if (!oldCache.font.equals(newCache.font)) {
            div.style.setProperty('font-family', this.font.fontFamily);
            div.style.setProperty('font-size', "".concat(this.font.fontSize, "px"));
            div.style.setProperty('font-weight', "".concat(this.font.fontWeight));
            div.style.setProperty('font-style', "".concat(this.font.fontStyle));
        }
        if (oldCache.text !== newCache.text) {
            div.innerHTML = label.text;
        }
        // update the cache
        ;
        element['data-cache'] = newCache;
        // move container to correct location
        var transform = yfiles_1.LabelStyleBase.createLayoutTransform(context, label.layout, true);
        transform.applyTo(foreignObject);
        return oldVisual;
    };
    HtmlLabelStyle.prototype.getPreferredSize = function (label) {
        var div = document.createElement('div');
        div.style.setProperty('display', 'inline-block');
        div.innerHTML = label.text;
        document.body.appendChild(div);
        var clientRect = div.getBoundingClientRect();
        document.body.removeChild(div);
        var scale = this.font.fontSize / 11;
        return new yfiles_1.Size(clientRect.width * scale, clientRect.height * scale);
    };
    HtmlLabelStyle.prototype.updateFont = function (data) {
        var font = NodeStyleSettings_1.NodeStyleSettings.getFontByFontString(data.font);
        if (font) {
            this.font = font;
        }
    };
    return HtmlLabelStyle;
}(yfiles_1.LabelStyleBase));
exports["default"] = HtmlLabelStyle;
function createRenderDataCache(label, font) {
    return {
        text: label.text,
        font: font,
        layout: label.layout
    };
}


/***/ }),

/***/ "WrRr":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MyImageNodeStyle = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var styles_other_1 = __webpack_require__("AuVx");
var yfiles_1 = __webpack_require__("GsAs");
var MyImageNodeStyle = /** @class */ (function (_super) {
    __extends(MyImageNodeStyle, _super);
    function MyImageNodeStyle(baseUrl) {
        var _this = _super.call(this) || this;
        _this.baseUrl = baseUrl;
        _this.imageNode = new view_component_1.SimpleNode();
        _this.imageNode.layout = new view_component_1.Rect(0, 0, 64, 64);
        return _this;
    }
    MyImageNodeStyle.prototype.getImageStyle = function (node) {
        var data = node.tag;
        var imageStyle;
        if (data.link && data.link != '') {
            // load map preview
            // return this.baseUrl + 'upload/images/sm-view/maps/' + data.link + '.jpg';
            imageStyle = new styles_other_1.ImageNodeStyle();
            imageStyle.image = this.baseUrl + 'src/classes/modules/smview_maps/theme/img/icons/network_128.png';
        }
        else {
            if (data.image_file) {
                // base64 encoded string, prepared on server
                var mimeType = data.image_mime_type ? data.image_mime_type : 'png';
                var dataUri = 'data:image/' + mimeType + ';base64,' + data.image_file;
                imageStyle = new styles_other_1.ImageNodeStyle(dataUri);
            }
            else {
                var url = data.imagepath ? data.imagepath.replace(this.baseUrl, '') : '';
                imageStyle = new styles_other_1.ImageNodeStyle();
                imageStyle.image = this.baseUrl + url;
            }
        }
        return imageStyle;
    };
    MyImageNodeStyle.getImageNode = function (node) {
        var data = node.tag;
        var imageNode = new view_component_1.SimpleNode();
        imageNode.layout = new view_component_1.Rect(0, 0, 64, 64);
        if (data) {
            var pos = data.position.split(',');
            var x = pos[0];
            var y = pos[1];
            imageNode.layout = new view_component_1.Rect(x, y, data.width, data.height);
        }
        return imageNode;
    };
    MyImageNodeStyle.prototype.createVisual = function (context, node) {
        var layout = node.layout.toRect();
        // create the decoration
        var imageStyle = this.getImageStyle(node);
        this.imageNode = MyImageNodeStyle.getImageNode(node);
        this.imageNode.layout = this.getImageNodeLayout(layout);
        var decorationRenderer = imageStyle.renderer.getVisualCreator(this.imageNode, imageStyle);
        var decorationVisual = decorationRenderer.createVisual(context);
        var group = new yfiles_1.SvgVisualGroup();
        group.add(decorationVisual);
        return group;
    };
    MyImageNodeStyle.prototype.updateVisual = function (context, oldVisual, node) {
        var imageStyle = this.getImageStyle(node);
        return imageStyle.renderer.getVisualCreator(node, imageStyle).updateVisual(context, oldVisual);
    };
    MyImageNodeStyle.prototype.getImageNodeLayout = function (nodeLayout) {
        var size = this.imageNode.layout.toSize();
        return new view_component_1.Rect(nodeLayout.x, nodeLayout.y, size.width, size.height);
    };
    return MyImageNodeStyle;
}(view_component_1.NodeStyleBase));
exports.MyImageNodeStyle = MyImageNodeStyle;


/***/ }),

/***/ "q0tI":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NodeStyleSettings = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var TextNodeStyle_1 = __webpack_require__("v4wb");
var ShapeNodeStyle_1 = __webpack_require__("Ms6H");
var ImageNodeStyle_1 = __webpack_require__("WrRr");
var NodeStyleSettings = /** @class */ (function () {
    function NodeStyleSettings() {
    }
    NodeStyleSettings.getNodeStyle = function (nodeData, baseUrl) {
        if (nodeData.realizertype == '2' || nodeData.realizertype == '1') {
            // shape node or text node
            if (parseInt(nodeData.shapetype) == 0 && parseInt(nodeData.textalignment) == 0) {
                return new TextNodeStyle_1.TextNodeStyle();
            }
            else {
                return new ShapeNodeStyle_1.MyShapeNodeStyle();
            }
        }
        if (nodeData.realizertype == '0') {
            // image node
            return new ImageNodeStyle_1.MyImageNodeStyle(baseUrl);
        }
    };
    NodeStyleSettings.getPosition = function (position) {
        return NodeStyleSettings.positions[position] ? NodeStyleSettings.positions[position] : view_component_1.ExteriorLabelModelPosition.SOUTH;
    };
    NodeStyleSettings.getIndexOfPosition = function (position) {
        var index = 109;
        for (var key in NodeStyleSettings.positions) {
            if (NodeStyleSettings.positions.hasOwnProperty(key)) {
                var pos = NodeStyleSettings.positions[key];
                if (pos == position) {
                    index = parseInt(key);
                }
            }
        }
        return index;
    };
    NodeStyleSettings.getNodeSetupByMapObject = function (mapObject) {
        var fnt = mapObject.font.split(';');
        if (fnt.length != 3) {
            return;
        }
        var style = parseInt(fnt[1]);
        var nodeSetup = {
            family: fnt[0],
            size: parseInt(fnt[2]),
            color: mapObject.textcolor,
            background_color: mapObject.fillcolor,
            is_bold: style == 1 || style == 3,
            is_italic: style == 2 || style == 3,
            shape_type: parseInt(mapObject.shapetype)
        };
        return nodeSetup;
    };
    NodeStyleSettings.getFontByFontString = function (font) {
        var fnt = font.split(';');
        if (fnt.length != 3) {
            return;
        }
        var style = parseInt(fnt[1]);
        return new view_component_1.Font({
            fontFamily: fnt[0],
            fontSize: parseInt(fnt[2]),
            fontWeight: style == 1 || style == 3 ? 'bold' : 'normal',
            fontStyle: style == 2 || style == 3 ? view_component_1.FontStyle.ITALIC : view_component_1.FontStyle.NORMAL
        });
    };
    NodeStyleSettings.getFontStringByNodeSetup = function (nodeSetup) {
        var font = nodeSetup.family ? nodeSetup.family : 'Dialog';
        var fontStyle = 0;
        if (nodeSetup.is_bold) {
            fontStyle = 1;
        }
        if (nodeSetup.is_italic) {
            fontStyle = 2;
        }
        if (nodeSetup.is_bold && nodeSetup.is_italic) {
            fontStyle = 3;
        }
        font += ';' + fontStyle + ';';
        font += nodeSetup.size ? nodeSetup.size : 14;
        return font;
    };
    NodeStyleSettings.getLabelPosition = function (nodeCenter, labelCenter) {
        // todo: find a better way to get label position
        var pos = view_component_1.ExteriorLabelModelPosition.SOUTH;
        if (nodeCenter.x == labelCenter.x && nodeCenter.y > labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.NORTH;
        }
        if (nodeCenter.x == labelCenter.x && nodeCenter.y < labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.SOUTH;
        }
        if (nodeCenter.y == labelCenter.y && nodeCenter.x > labelCenter.x) {
            pos = view_component_1.ExteriorLabelModelPosition.WEST;
        }
        if (nodeCenter.y == labelCenter.y && nodeCenter.x < labelCenter.x) {
            pos = view_component_1.ExteriorLabelModelPosition.EAST;
        }
        if (nodeCenter.x > labelCenter.x && nodeCenter.y > labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.NORTH_WEST;
        }
        if (nodeCenter.x > labelCenter.x && nodeCenter.y < labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.SOUTH_WEST;
        }
        if (nodeCenter.x < labelCenter.x && nodeCenter.y > labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.NORTH_EAST;
        }
        if (nodeCenter.x < labelCenter.x && nodeCenter.y < labelCenter.y) {
            pos = view_component_1.ExteriorLabelModelPosition.SOUTH_EAST;
        }
        return pos;
    };
    NodeStyleSettings.positions = {
        104: view_component_1.ExteriorLabelModelPosition.NORTH_WEST,
        105: view_component_1.ExteriorLabelModelPosition.NORTH_EAST,
        106: view_component_1.ExteriorLabelModelPosition.SOUTH_EAST,
        107: view_component_1.ExteriorLabelModelPosition.SOUTH_WEST,
        108: view_component_1.ExteriorLabelModelPosition.NORTH,
        109: view_component_1.ExteriorLabelModelPosition.SOUTH,
        110: view_component_1.ExteriorLabelModelPosition.EAST,
        111: view_component_1.ExteriorLabelModelPosition.WEST
    };
    return NodeStyleSettings;
}());
exports.NodeStyleSettings = NodeStyleSettings;


/***/ }),

/***/ "Ms6H":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MyShapeNodeStyle = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var AbstractNodeStyle_1 = __webpack_require__("EbKB");
var MyShapeNodeStyle = /** @class */ (function (_super) {
    __extends(MyShapeNodeStyle, _super);
    function MyShapeNodeStyle() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MyShapeNodeStyle.prototype.createVisual = function (context, node) {
        // This implementation creates a 'g' element and uses it as a container for the rendering of the node.
        var g = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
        // Render the node
        this.render(context, node, g);
        // set the location
        view_component_1.SvgVisual.setTranslate(g, node.layout.x, node.layout.y);
        return new view_component_1.SvgVisual(g);
    };
    MyShapeNodeStyle.prototype.render = function (context, node, container) {
        // Create Defs section in container
        var defs = window.document.createElementNS('http://www.w3.org/2000/svg', 'defs');
        container.appendChild(defs);
        var shapeType;
        if (node.tag && node.tag.shapetype) {
            shapeType = node.tag.shapetype;
        }
        var shape;
        shapeType = parseInt(shapeType);
        // with realizer = 1
        switch (shapeType) {
            case 0:
                shape = this.getRect(node);
                break; // Rechteck
            case 1:
                shape = this.getRoundRect(node);
                break; // Rechteck, runde Ecken
            case 2:
                shape = MyShapeNodeStyle.getEllipse(node);
                break; // Kreis
            case 3:
                shape = this.getRhomboid(node);
                break; // Parallologramm
            case 4:
                shape = this.getBanner(node);
                break; // Banner
            case 5:
                shape = this.getTriangle(node);
                break; // Dreieck
            case 7:
                shape = this.getStopSign(node);
                break; // Stoppschild
            case 8:
                shape = this.getRhomb(node);
                break; // Raute
            case 9:
                shape = this.getConeTop(node);
                break; // Trichter oben
            case 10:
                shape = this.getConeBottom(node);
                break; // Trichter unten
            default:
                shape = this.getRect(node);
                break;
        }
        // set fill color
        var color = this.getNodeColor(node);
        shape.setAttribute('fill', color);
        // set border color
        shape.setAttribute('stroke-width', '0.8');
        shape.setAttribute('stroke', this.getBorderColor(node));
        if (shape) {
            container.appendChild(shape);
        }
    };
    MyShapeNodeStyle.prototype.getRoundRect = function (node) {
        var rect = _super.prototype.getRect.call(this, node);
        rect.setAttribute('rx', '10');
        rect.setAttribute('ry', '10');
        return rect;
    };
    MyShapeNodeStyle.getEllipse = function (node) {
        var shape = window.document.createElementNS('http://www.w3.org/2000/svg', 'ellipse');
        var nodeSize = node.layout.toSize();
        var w = nodeSize.width * 0.5;
        var h = nodeSize.height * 0.5;
        shape.cx.baseVal.value = w;
        shape.cy.baseVal.value = h;
        shape.rx.baseVal.value = w;
        shape.ry.baseVal.value = h;
        return shape;
    };
    MyShapeNodeStyle.prototype.getTriangle = function (node) {
        var nodeSize = node.layout.toSize();
        var w2 = nodeSize.width * 0.5;
        var coords = [
            [0, nodeSize.height],
            [nodeSize.width, nodeSize.height],
            [w2, 0],
            [0, nodeSize.height]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getRhomb = function (node) {
        var nodeSize = node.layout.toSize();
        var w2 = nodeSize.width * 0.5;
        var h2 = nodeSize.height * 0.5;
        var coords = [
            [0, h2],
            [w2, nodeSize.height],
            [nodeSize.width, h2],
            [w2, 0],
            [0, h2]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getRhomboid = function (node) {
        var nodeSize = node.layout.toSize();
        var offset = 14;
        var coords = [
            [0, nodeSize.height],
            [nodeSize.width - offset, nodeSize.height],
            [nodeSize.width, 0],
            [offset, 0],
            [0, nodeSize.height]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getBanner = function (node) {
        var nodeSize = node.layout.toSize();
        var h2 = nodeSize.height * 0.5;
        var offset = 14;
        var coords = [
            [0, h2],
            [offset, nodeSize.height],
            [nodeSize.width - offset, nodeSize.height],
            [nodeSize.width, h2],
            [nodeSize.width - offset, 0],
            [offset, 0],
            [0, h2]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getStopSign = function (node) {
        var nodeSize = node.layout.toSize();
        var w3 = nodeSize.width * 0.33;
        var h3 = nodeSize.height * 0.33;
        var coords = [
            [0, h3],
            [0, h3 * 2],
            [w3, nodeSize.height],
            [w3 * 2, nodeSize.height],
            [nodeSize.width, h3 * 2],
            [nodeSize.width, h3],
            [w3 * 2, 0],
            [w3, 0],
            [0, h3]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getConeTop = function (node) {
        var nodeSize = node.layout.toSize();
        var offset = 30;
        var coords = [
            [0, nodeSize.height],
            [nodeSize.width, nodeSize.height],
            [nodeSize.width - offset, 0],
            [offset, 0],
            [0, nodeSize.height]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.getConeBottom = function (node) {
        var nodeSize = node.layout.toSize();
        var offset = 30;
        var coords = [
            [0, 0],
            [offset, nodeSize.height],
            [nodeSize.width - offset, nodeSize.height],
            [nodeSize.width, 0],
            [0, 0]
        ];
        return this.coordsToShape(coords);
    };
    MyShapeNodeStyle.prototype.coordsToShape = function (coords) {
        var shape = window.document.createElementNS('http://www.w3.org/2000/svg', 'polyline');
        var points = '';
        coords.forEach(function (c) {
            if (points.length > 0) {
                points += ' ';
            }
            points += c[0] + ', ' + c[1];
        });
        shape.setAttribute('points', points);
        return shape;
    };
    MyShapeNodeStyle.prototype.getDefaultFillColor = function () {
        return '#7784AA';
    };
    MyShapeNodeStyle.prototype.getDefaultBorderColor = function () {
        return '#444444';
    };
    return MyShapeNodeStyle;
}(AbstractNodeStyle_1.AbstractNodeStyle));
exports.MyShapeNodeStyle = MyShapeNodeStyle;


/***/ }),

/***/ "a17Q":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.TextLabelStyle = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var NodeStyleSettings_1 = __webpack_require__("q0tI");
var yfiles_1 = __webpack_require__("GsAs");
var TextLabelStyle = /** @class */ (function (_super) {
    __extends(TextLabelStyle, _super);
    function TextLabelStyle(nodeSetup) {
        var _this = _super.call(this) || this;
        _this.font = new view_component_1.Font({
            fontFamily: nodeSetup ? nodeSetup.family : 'Dialog',
            fontSize: nodeSetup ? nodeSetup.size : 14
        });
        return _this;
    }
    TextLabelStyle.prototype.render = function (label, container, labelLayout) {
        var rect = this.createBorderRect(label, container, labelLayout);
        var text;
        if (container.childElementCount > 1) {
            text = container.childNodes.item(1);
        }
        else {
            text = window.document.createElementNS('http://www.w3.org/2000/svg', 'text');
            container.appendChild(text);
        }
        if (label.owner.tag) {
            var data = label.owner.tag;
            this.updateFont(data);
            text.setAttribute('fill', data.textcolor);
        }
        // assign all the values of the font to the text element's attributes
        this.font.applyTo(text);
        // SVG does not provide out-of-the box text wrapping.
        // The following line uses a convenience method that implements text wrapping
        // with ellipsis by splitting the text and inserting tspan elements as children
        // of the text element. It is not mandatory to use this method, since the same
        // things could be done manually.
        var textContent = view_component_1.TextRenderSupport.addText(text, label.text, this.font, labelLayout.toSize(), view_component_1.TextWrapping.NONE);
        // calculate the size of the text element
        var textSize = view_component_1.TextRenderSupport.measureText(textContent, this.font);
        // calculate horizontal offset for centered alignment
        var translateX = (labelLayout.width - textSize.width) * 0.5;
        // calculate vertical offset for centered alignment
        var translateY = (labelLayout.height - textSize.height) * 0.5;
        text.setAttribute('transform', "translate(".concat(translateX, " ").concat(translateY, ")"));
        // resize and place border rectangle
        var offsetWidth = 10;
        var offsetHeight = 4;
        var width = textSize.width + offsetWidth;
        var height = textSize.height + offsetHeight;
        rect.setAttribute('width', width.toString());
        rect.setAttribute('height', height.toString());
        translateX -= (offsetWidth / 2);
        translateY -= (offsetHeight / offsetHeight);
        rect.setAttribute('transform', "translate(".concat(translateX, " ").concat(translateY, ")"));
        if (label.owner instanceof yfiles_1.INode) {
            var node = label.owner;
            if (node.tag && node.tag.realizertype == '0' && width < node.layout.width) {
                // resize label to node's width
                var diff = node.layout.width - width;
                width += diff;
                rect.setAttribute('width', width.toString());
                translateX -= (diff / 2);
                rect.setAttribute('transform', "translate(".concat(translateX, " ").concat(translateY, ")"));
            }
        }
        while (container.childElementCount > 2) {
            container.removeChild(container.childNodes.item(2));
        }
    };
    TextLabelStyle.prototype.createBorderRect = function (label, container, labelLayout) {
        var rect;
        if (container.childElementCount > 0) {
            rect = container.childNodes.item(0);
        }
        else {
            rect = window.document.createElementNS('http://www.w3.org/2000/svg', 'rect');
            container.appendChild(rect);
        }
        rect.width.baseVal.value = labelLayout.width;
        rect.height.baseVal.value = labelLayout.height;
        // border
        var mapObject = label.owner.tag ? label.owner.tag : null;
        var borderColor = 'none';
        if (mapObject && mapObject.labellinecolor) {
            borderColor = mapObject.labellinecolor;
        }
        rect.setAttribute('stroke', borderColor);
        rect.setAttribute('stroke-width', '0.5');
        // background color
        var color = null;
        if (mapObject && mapObject.realizertype == '0' && mapObject.fillcolor != null) {
            // use always fillcolor on image nodes
            color = mapObject.fillcolor;
        }
        if (mapObject && mapObject.status != null) {
            var status_1 = mapObject.status;
            switch (status_1) {
                case -1:
                    color = '#888888';
                    break;
                case 0:
                    color = '#78D168';
                    break;
                case 1:
                    color = '#FCFA90';
                    break;
                case 2:
                    color = '#E7A1A2';
                    break;
                case 3:
                    color = '#FAB47A';
                    break;
                case 4:
                    color = '#E7A1A2';
                    break;
                case 5:
                    color = '#FAB47A';
                    break;
            }
            this.updateFont(mapObject);
        }
        var htmlColor = color || 'none';
        rect.setAttribute('fill', htmlColor);
        return rect;
    };
    TextLabelStyle.prototype.createVisual = function (context, label) {
        // This implementation creates a 'g' element and uses it for the rendering of the label.
        var g = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
        // Render the label
        this.render(label, g, label.layout);
        // move container to correct location
        var transform = view_component_1.LabelStyleBase.createLayoutTransform(label.layout, true);
        transform.applyTo(g);
        // set data item
        g.setAttribute('data-internalId', 'MySimpleLabel');
        // todo: replace next line
        // g.setAttribute('data-item', label);
        return new view_component_1.SvgVisual(g);
    };
    TextLabelStyle.prototype.getPreferredSize = function (label) {
        // calculate width depending on text length
        var w = label.text.length * 7;
        if (label.text.length < 10) {
            // add an offset for short labels
            w += 15;
        }
        // add more space for upper letters
        if (label.text.length > 0) {
            var upperLetters = label.text.replace(/[^A-Z]/g, '').length;
            w += upperLetters * 2;
        }
        return new view_component_1.Size(w, 18);
    };
    TextLabelStyle.prototype.updateFont = function (data) {
        var font = NodeStyleSettings_1.NodeStyleSettings.getFontByFontString(data.font);
        if (font) {
            this.font = font;
        }
    };
    return TextLabelStyle;
}(view_component_1.LabelStyleBase));
exports.TextLabelStyle = TextLabelStyle;


/***/ }),

/***/ "v4wb":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.TextNodeStyle = void 0;
__webpack_require__("gKY+");
var view_component_1 = __webpack_require__("WBwp");
var AbstractNodeStyle_1 = __webpack_require__("EbKB");
var TextNodeStyle = /** @class */ (function (_super) {
    __extends(TextNodeStyle, _super);
    function TextNodeStyle() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TextNodeStyle.prototype.createVisual = function (context, node) {
        // This implementation creates a 'g' element and uses it as a container for the rendering of the node.
        var g = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
        // Render the node
        this.render(context, node, g);
        // set the location
        view_component_1.SvgVisual.setTranslate(g, node.layout.x, node.layout.y);
        return new view_component_1.SvgVisual(g);
    };
    TextNodeStyle.prototype.render = function (context, node, container) {
        // Create Defs section in container
        var defs = window.document.createElementNS('http://www.w3.org/2000/svg', 'defs');
        container.appendChild(defs);
        var shape = this.getRect(node);
        // set border color
        // shape.setAttribute('stroke-width', '0.8')
        // shape.setAttribute('stroke', this.getBorderColor(node))
        if (shape) {
            container.appendChild(shape);
        }
    };
    TextNodeStyle.prototype.getDefaultFillColor = function () {
        return '#FFFFFF';
    };
    TextNodeStyle.prototype.getDefaultBorderColor = function () {
        return '#000000';
    };
    return TextNodeStyle;
}(AbstractNodeStyle_1.AbstractNodeStyle));
exports.TextNodeStyle = TextNodeStyle;


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/chunk loaded */
/******/ 	!function() {
/******/ 		var deferred = [];
/******/ 		__webpack_require__.O = function(result, chunkIds, fn, priority) {
/******/ 			if(chunkIds) {
/******/ 				priority = priority || 0;
/******/ 				for(var i = deferred.length; i > 0 && deferred[i - 1][2] > priority; i--) deferred[i] = deferred[i - 1];
/******/ 				deferred[i] = [chunkIds, fn, priority];
/******/ 				return;
/******/ 			}
/******/ 			var notFulfilled = Infinity;
/******/ 			for (var i = 0; i < deferred.length; i++) {
/******/ 				var chunkIds = deferred[i][0];
/******/ 				var fn = deferred[i][1];
/******/ 				var priority = deferred[i][2];
/******/ 				var fulfilled = true;
/******/ 				for (var j = 0; j < chunkIds.length; j++) {
/******/ 					if ((priority & 1 === 0 || notFulfilled >= priority) && Object.keys(__webpack_require__.O).every(function(key) { return __webpack_require__.O[key](chunkIds[j]); })) {
/******/ 						chunkIds.splice(j--, 1);
/******/ 					} else {
/******/ 						fulfilled = false;
/******/ 						if(priority < notFulfilled) notFulfilled = priority;
/******/ 					}
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferred.splice(i--, 1)
/******/ 					var r = fn();
/******/ 					if (r !== undefined) result = r;
/******/ 				}
/******/ 			}
/******/ 			return result;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	!function() {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	!function() {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// [resolve, reject, Promise] = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			"main": 0
/******/ 		};
/******/ 		
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		__webpack_require__.O.j = function(chunkId) { return installedChunks[chunkId] === 0; };
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = function(parentChunkLoadingFunction, data) {
/******/ 			var chunkIds = data[0];
/******/ 			var moreModules = data[1];
/******/ 			var runtime = data[2];
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0;
/******/ 			if(chunkIds.some(function(id) { return installedChunks[id] !== 0; })) {
/******/ 				for(moduleId in moreModules) {
/******/ 					if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 						__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 					}
/******/ 				}
/******/ 				if(runtime) var result = runtime(__webpack_require__);
/******/ 			}
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					installedChunks[chunkId][0]();
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			return __webpack_require__.O(result);
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunkmaps_app"] = self["webpackChunkmaps_app"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 	}();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module depends on other loaded chunks and execution need to be delayed
/******/ 	__webpack_require__.O(undefined, ["yfiles","vendors"], function() { return __webpack_require__("Y10B"); })
/******/ 	var __webpack_exports__ = __webpack_require__.O(undefined, ["yfiles","vendors"], function() { return __webpack_require__("KkGx"); })
/******/ 	__webpack_exports__ = __webpack_require__.O(__webpack_exports__);
/******/ 	
/******/ })()
;