'use strict'

import 'yfiles/view-layout-bridge.js'
import { GraphViewerInputMode } from 'yfiles/view-component'

export class MyViewerInputMode extends GraphViewerInputMode {
    private readonly basePath: string;

    constructor (basePath: string) {
      super()
      this.basePath = basePath
    }

  onCanvasClicked(evt) {
      if (evt.clickCount != 2) {
          return;
      }

      if (! window.location.search.includes('nav=link')) {
          return;
      }

      // if location contains "nav=link" go back and load parent map
      window.history.back();
  }

  onItemDoubleClicked(evt) {
      if (! evt.item.tag) {
          return;
      }

      let map_id = evt.item.tag.link;
      if (! map_id) {
          return;
      }

      // load child map
      let url = window.location.origin + window.location.pathname;
      url += this.basePath + '&nav=link&treeNode=' + map_id + '&instance_id=' + map_id;
      window.location.href = url;
  }
}
