'use strict'

import { ApiProps } from './input_modes/NodeEditorInputMode'

export function api (method: string, params: {}, apiProps: ApiProps) {
  params = params || {}

  return fetch(apiProps.api_url, {
    method: 'POST',
    headers: {
      Accept: 'application/json',
      'Content-Type': 'application/json',
      'X-RPC-Auth-Session': apiProps.session
    },
    credentials: 'same-origin',
    body: JSON.stringify({
      jsonrpc: '2.0',
      version: '2.0',
      id: 1,
      method,
      params: {
        apikey: apiProps.api_key,
        ...params
      }
    })
  }).then(res => res.json())
}
