import { INode, InputModeEventArgs, MoveInputMode } from 'yfiles'
import { MapObject } from '../MapsCompose'
import { api } from '../ajax'
import { ApiProps } from './NodeEditorInputMode'

export class ChangeNodePositionInputMode extends MoveInputMode {
    private readonly api_props: ApiProps;

    constructor (api_props: ApiProps) {
      super()
      this.api_props = api_props
    }

    onDragFinished (evt: InputModeEventArgs) {
      super.onDragFinished(evt)

      const node: INode = this.api_props.graph_component.selection.selectedNodes.elementAt(0)
      const map_object: MapObject = node.tag as MapObject
      const x = node.layout.x + (node.layout.width / 2)
      const y = node.layout.y + (node.layout.height / 2)
      const position = parseInt(x.toString()) + ',' + parseInt(y.toString())
      api('shd.map_object.update',
        {
          mapobject_id: map_object.mapobject_id,
          position: position
        },
        this.api_props).then(() => {
        console.debug('node position successful changed')
      })
    }
}
