import { HandleInputMode, INode, InputModeEventArgs } from 'yfiles'
import { MapObject } from '../MapsCompose'
import { api } from '../ajax'
import { ApiProps } from './NodeEditorInputMode'

export class ChangeNodeSizeInputMode extends HandleInputMode {
    private readonly apiProps: ApiProps;

    constructor (apiProps: ApiProps) {
      super()
      this.apiProps = apiProps
    }

    onDragFinished (evt: InputModeEventArgs) {
      super.onDragFinished(evt)

      const node: INode = this.apiProps.graph_component.selection.selectedNodes.elementAt(0)
      const mapObject: MapObject = node.tag as MapObject
      api('shd.map_object.update',
        {
          mapobject_id: mapObject.mapobject_id,
          width: node.layout.width,
          height: node.layout.height
        },
        this.apiProps).then(() => {
        console.debug('node size successful changed')
      })
    }
}
