<?php

/**
 * i-doit
 *
 * DAO: List of SM-VIEW Maps Assigned Maps.
 *
 * @package    i-doit
 * @subpackage smview_maps
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2021 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_cmdb_dao_list_catg_smview_maps_assigned_maps extends isys_cmdb_dao_list
{

    /**
     * Return constant of category.
     *
     * @return integer
     */
    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_MAPS_ASSIGNED_MAPS');
    }

    /**
     * Return constant of category type.
     *
     * @return integer
     */
    public function get_category_type()
    {
        return C__CMDB__CATEGORY__TYPE_GLOBAL;
    }

    /**
     * Returns array with table headers.
     *
     * @return array
     */
    public function get_fields()
    {
        return [
            "map_title"   => 'LC__CMDB__CATG__SMVIEW_MAPS__MAP_NAME',
            "type"        => "LC__CMDB__CATG__SMVIEW_MAPS__ASSIGNMENT_TYPE",
            "description" => 'LC__UNIVERSAL__DESCRIPTION',

        ];
    }

    /**
     * Modify row method will be called for each row to alter its content.
     *
     * @param  array &$p_row
     * @throws Exception
     */
    public function modify_row(&$p_row)
    {
        // set category item ID to generate a link in HTML list
        $p_row['isys_catg_smview_maps_assigned_maps_list__id'] = $p_row['map_id'];

        $lang = isys_application::instance()->container->get('language');
        $const = $p_row['type'];
        switch ($const) {
            case 'manual': $title = $lang->get('LC__CMDB__CATG__SMVIEW_MAPS__ASSIGNMENT_TYPE_MANUAL'); break;
            case 'implicit': $title = $lang->get('LC__CMDB__CATG__SMVIEW_MAPS__ASSIGNMENT_TYPE_IMPLICIT'); break;
            default: $title = '';
        }
        $p_row['type'] = $title;
    }
}
