<?php

/**
 * i-doit
 *
 * Module initializer
 *
 * @package    idoit
 * @subpackage smview_maps
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2018 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */

if (isys_module_manager::instance()->is_active('smview_maps')) {

    /* Initialize autoloader */
    if (include_once 'isys_module_smview_maps_autoload.class.php') {
        spl_autoload_register('isys_module_smview_maps_autoload::init');
    }

    \idoit\Psr4AutoloaderClass::factory()
            ->addNamespace('idoit\Module\smview_maps', __DIR__ . '/src/');

    /* Append custom module language file */
    global $g_idoit_language_short;

    $lang_path = __DIR__ . DS . 'lang' . DS . $g_idoit_language_short . '.inc.php';
    if (file_exists($lang_path)) {
        $l_language = include_once $lang_path;

        if (is_array($l_language)) {
            global $g_comp_template_language_manager;
            $g_comp_template_language_manager->append_lang($l_language);
        }
    }

    // Making the maps controller class available
    $GLOBALS['g_controller']['handler']['smview_maps_test_data_generator'] = ['class' => 'isys_handler_smview_maps_test_data_generator'];
}
