<?php

/**
 * i-doit
 *
 * Class autoloader.
 *
 * @package    idoit
 * @subpackage smview_maps
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2018 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_module_smview_maps_autoload extends isys_module_manager_autoload
{
    /**
     * Autoloader
     *
     * @param  string $className
     * @return boolean
     */
    public static function init($className)
    {
        $addOnPath = '/src/classes/modules/smview_maps/';
        $class_loader_paths = array(
            '/api/model/',
            '/api/model/maps/',
            '/cmdb/dao/',
            '/cmdb/dao/global/',
            '/cmdb/dao/list/',
            '/cmdb/ui/global/',
            '/handler/controller/',
        );

        //dynamic loading of classes
        foreach ($class_loader_paths as $clp) {
            $l_path = $clp . $className . '.class.php';
            if (! file_exists( __DIR__ . $l_path)) {
                continue;
            }

            if (parent::include_file($addOnPath . $l_path)) {
                isys_cache::keyvalue()->ns('autoload')->set($className, $addOnPath . $l_path);

                return true;
            }
        }

        $classMap = [
            'isys_dashboard_widgets_smview_maps'                         => '/widgets/isys_dashboard_widgets_smview_maps.class.php',
            'idoit\Module\Smview_Maps\Console\Command\TestDataGeneratorCommand' => '/src/Console/Command/TestDataGeneratorCommand.php',
        ];
        if (isset($classMap[$className])) {
            if (parent::include_file($addOnPath . $classMap[$className])) {
                isys_cache::keyvalue()->ns('autoload')->set($className, $addOnPath . $classMap[$className]);

                return true;
            }
        }

        return false;
    }
}
